
PROGRAM YAHTZEE;

(* VERSION 2.20 - 11-1995 --> 01-1996.

   AMELIORATION DE LA VERSION 2.10 :
   - UTILISATION DE LA SOURIS;
   - POSSIBILITE D'ANNULER UNE ECRITURE DANS LA FEUILLE DE POINTS;
   - AFFICHAGE DES SCORES COURANTS AVEC PRIMES COMPRISES;
   - 2 CLASSEMENTS : AVEC ET SANS PRIMES YAHTZEE;
   - POSSIBILITE DE FAIRE IMMEDIATEMENT UNE NOUVELLE PARTIE. *)

{$M 65520,0,655360}
{$I-}

Uses TXT,        (* VERSION 2.00 : GESTION D'ECRAN *)
     YAH_HARD,   (* COMPLEMENT TXT 2.00 (MODULES VERSION 3.00) - RECONNAISSANCE DU HARDWARE *)
     YAH_DECL,   (* DECLARATIONS ET MODULES GENERAUX *)
     YAH_DLGS,   (* BOITES DE DIALOGUE GENERALES *)
     YAH_DRAW,   (* MODULES D'AFFICHAGE DES DES ET DE LA FEUILLE DE POINTS *)
     YAH_CLAS,   (* CLASSEMENTS ET SAUVETAGES SUR DISQUE *)
     YAH_HELP;   (* REGLES DU JEU ET MODE D'EMPLOI DU PROGRAMME *)


Function TRAITEMENT_DES (Joueur:byte) : boolean;
(* TRAITEMENT DU TIRAGE DE DES.
   RETOURNE true SI LES 5 DES SONT SELECTIONNES (ET DONC SI FIN DES LANCERS). *)
Var n,y,ClrCadre:byte;
    xCourant,yCourant,FondCourant,CouleurCourante,Haut,Bas:word;
    Entree:char;
    Fin:boolean;
          Procedure AFFICHAGE_CADRE;
          (* CADRE AUTOUR DU MESSAGE "GARDER" OU "RELANCER" A LA LIGNE y *)
          Begin
            txtback(black); txtcolour(ClrCadre);
            txtmove(8,y-1); txtwrite('ͻ');
            txtmove(8,y); txtwrite(''); txtmove(21,y); txtwrite('');
            txtmove(8,y+1); txtwrite('ͼ');
          End;
          Procedure EFFACEMENT_CADRE;
          (* EFFACEMENT CADRE AUTOUR DU MESSAGE "GARDER" OU "RELANCER" A LA LIGNE y *)
          Begin
            txtback(black); txtcolour(lightgrey);
            txtmove(8,y-1); txtwrite('              ');
            txtmove(8,y); txtwrite(' '); txtmove(21,y); txtwrite(' ');
            txtmove(8,y+1); txtwrite('              ');
          End;
Begin
  if ModeEcran = ModeCouleur then ClrCadre:=lightcyan else ClrCadre:=white;
  xCourant:=windx; yCourant:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtgetcurssize(Haut,Bas); txtcursoff;
  y:=2; for n:=1 to 5 do begin AFFICHAGE_GARDER_REJOUER(n,y); inc(y,5); end;
  txtflush; mouseeventparams.me_modified:=false;
  n:=1; Fin:=false; y:=2; AFFICHAGE_CADRE;
  if Souris then Void:=txtmousecurson;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   1:begin   (* ALT-ESCAPE OU ALTGR-ESCAPE : TRICHER (YAHTZEE) *)
                       if Souris then Void:=txtmousecursoff; EFFACEMENT_CADRE;
                       Fin:=true; Tricher:=true;
                     end;
                   59:begin   (* F1 : REGLES DU JEU *)
                        if Souris then Void:=txtmousecursoff;
                        REGLES_DU_JEU;
                        if Souris then Void:=txtmousecurson;
                      end;
                   60:begin   (* F2 : SITUATION ACTUELLE DES POINTS *)
                        if Souris then Void:=txtmousecursoff;
                        SITUATION_ACTUELLE(Joueur);
                        if Souris then Void:=txtmousecurson;
                      end;
                   67:begin   (* F9 : NOUVELLE PARTIE *)
                        if Souris then Void:=txtmousecursoff;
                        FinPartie:=CONFIRMATION(1); if FinPartie then begin Fin:=true; TRAITEMENT_DES:=true; end;
                        if Souris then Void:=txtmousecurson;
                      end;
                   68:begin   (* F10 : FIN DU PROGRAMME *)
                        if Souris then Void:=txtmousecursoff;
                        FinJeu:=CONFIRMATION(2); if FinJeu then begin Fin:=true; TRAITEMENT_DES:=true; end;
                        if Souris then Void:=txtmousecurson;
                      end;
                   72:begin   (* FLECHE HAUT : DE PRECEDENT *)
                        if Souris then Void:=txtmousecursoff;
                        EFFACEMENT_CADRE;
                        if y = 2 then begin y:=22; n:=5; end else begin dec(y,5); dec(n); end;
                        AFFICHAGE_CADRE;
                        if Souris then Void:=txtmousecurson;
                      end;
                   80:begin   (* FLECHE BAS : DE SUIVANT *)
                        if Souris then Void:=txtmousecursoff;
                        EFFACEMENT_CADRE;
                        if y = 22 then begin y:=2; n:=1; end else begin inc(y,5); inc(n); end;
                        AFFICHAGE_CADRE;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             13:begin   (* ENTER : "GARDER" OU "RELANCER" *)
                  TableauGarder[n]:=not(TableauGarder[n]);
                  if Souris then Void:=txtmousecursoff;
                  AFFICHAGE_GARDER_REJOUER(n,y);
                  if Souris then Void:=txtmousecurson;
                end;
             27:begin   (* ESCAPE : FIN DE LA SELECTION DES DES *)
                  if Souris then Void:=txtmousecursoff; EFFACEMENT_CADRE;
                  Fin:=true;
                end;
             255:begin   (* ALT-255 : MESSAGE PERSONNEL *)
                   if Souris then Void:=txtmousecursoff;
                   MESSAGE_PERSONNEL;
                   if Souris then Void:=txtmousecurson;
                 end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             case me_x of
               0..19:case me_y of
                       1..4:begin
                              Void:=txtmousecursoff;
                              EFFACEMENT_CADRE; y:=2; n:=1; AFFICHAGE_CADRE;
                              TableauGarder[n]:=not(TableauGarder[n]); AFFICHAGE_GARDER_REJOUER(n,y);
                              Void:=txtmousecurson;
                            end;
                       6..9:begin
                              Void:=txtmousecursoff;
                              EFFACEMENT_CADRE; y:=7; n:=2; AFFICHAGE_CADRE;
                               TableauGarder[n]:=not(TableauGarder[n]); AFFICHAGE_GARDER_REJOUER(n,y);
                              Void:=txtmousecurson;
                            end;
                       11..14:begin
                                Void:=txtmousecursoff;
                                EFFACEMENT_CADRE; y:=12; n:=3; AFFICHAGE_CADRE;
                                TableauGarder[n]:=not(TableauGarder[n]); AFFICHAGE_GARDER_REJOUER(n,y);
                                Void:=txtmousecurson;
                              end;
                       16..19:begin
                                Void:=txtmousecursoff;
                                EFFACEMENT_CADRE; y:=17; n:=4; AFFICHAGE_CADRE;
                                TableauGarder[n]:=not(TableauGarder[n]); AFFICHAGE_GARDER_REJOUER(n,y);
                                Void:=txtmousecurson;
                              end;
                       21..24:begin
                                Void:=txtmousecursoff;
                                EFFACEMENT_CADRE; y:=22; n:=5; AFFICHAGE_CADRE;
                                TableauGarder[n]:=not(TableauGarder[n]); AFFICHAGE_GARDER_REJOUER(n,y);
                                Void:=txtmousecurson;
                              end;
                     end;
               28..45:case me_y of
                        15:begin   (* BOUTON "FIN CHOIX DES" *)
                             Void:=txtmousecursoff; EFFACEMENT_CADRE;
                             Fin:=true;
                           end;
                        16:begin   (* BOUTON "REGLES DU JEU" *)
                             Void:=txtmousecursoff; REGLES_DU_JEU; Void:=txtmousecurson;
                           end;
                        17:begin   (* BOUTON "POINTS ACTUELS" *)
                             Void:=txtmousecursoff; SITUATION_ACTUELLE(Joueur); Void:=txtmousecurson;
                           end;
                        18:begin   (* BOUTON "NOUVELLE PARTIE" *)
                             Void:=txtmousecursoff;
                             FinPartie:=CONFIRMATION(1); if FinPartie then begin Fin:=true; TRAITEMENT_DES:=true; end;
                             Void:=txtmousecurson;
                           end;
                        19:begin   (* BOUTON "QUITTER LE JEU" *)
                             Void:=txtmousecursoff;
                             FinJeu:=CONFIRMATION(2); if FinJeu then begin Fin:=true; TRAITEMENT_DES:=true; end;
                             Void:=txtmousecurson;
                           end;
                      end;
             end;
             me_modified:=false;
           end;
  until Fin;
  if (not FinPartie) and (not FinJeu)
     then   (* COMPTAGE DES DES GARDES POUR VOIR SI FIN LANCER *)
       begin
         y:=0; for n:=1 to 5 do if TableauGarder[n] then inc(y);
         TRAITEMENT_DES:=(y = 5);
       end;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(xCourant,yCourant); txtcurssize(Haut,Bas);
End;


Procedure RELANCER;
(* ATTRIBUTION D'UN NOUVEAU MONTANT AUX DES A RELANCER *)
(* MODIFIEE VERSION 2.20 *)
Var n,y:byte;
Begin
  y:=1;
  for n:=1 to 5 do
    begin
      if not TableauGarder[n]
         then
           begin
             repeat TableauDes[n]:=random(7); until TableauDes[n] in [1..6];
             AFFICHAGE_DE(0,y,TableauDes[n]);
           end;
      inc(y,5);
    end;
End;


Procedure LANCER_YAHTZEE;
(* REPETITION DES DES SELECTIONNES DE MANIERE A FORMER UN YAHTZEE (TRICHERIE !) *)
(* CREEE VERSION 2.20 *)
Var n,y,Selection:byte;
Begin
  n:=1; Selection:=0;
  while n <= 5 do if TableauGarder[n] then begin Selection:=TableauDes[n]; n:=6; end else inc(n);
  y:=1;
  for n:=1 to 5 do
    begin
      if not TableauGarder[n]
         then
           begin
             if Selection = 0 then TableauDes[n]:=TableauDes[1] else TableauDes[n]:=Selection;
             AFFICHAGE_DE(0,y,TableauDes[n]);
           end;
      inc(y,5);
    end;
  Tricher:=false;
End;


Procedure TRI_DES;
(* TRI DES 5 DES PAR ORDRE CROISSANT *)
(* CONSERVEE VERSION 2.20 *)
Var l,m,n,Sauve:byte;
Begin
  l:=1;
  while l <= 4 do
    begin
      m:=l + 1;
      while m <= 5 do
        begin
          if TableauDes[m] < TableauDes[l]
             then
               begin
                 Sauve:=TableauDes[m];
                 for n:=m downto (l+1) do TableauDes[n]:=TableauDes[n-1];
                 TableauDes[l]:=Sauve;
               end;
          inc(m);
        end;
      inc(l);
    end;
End;


Function TEST_YAHTZEE : boolean;
(* RETOURNE true SI LES 5 DES FORMENT UN YAHTZEE *)
(* MODIFIEE VERSION 2.20 *)
Begin
  TEST_YAHTZEE:=(TableauDes[1] = TableauDes[2]) and (TableauDes[1] = TableauDes[3]) and
                (TableauDes[1] = TableauDes[4]) and (TableauDes[1] = TableauDes[5]);
End;


Function TEST_BRELAN : boolean;
(* RETOURNE true SI LES 5 DES FORMENT UN BRELAN *)
(* MODIFIEE VERSION 2.20 *)
Var m,n,Compteur:byte;
Begin
  m:=0;
  repeat
    inc(m);
    Compteur:=0;
    for n:=1 to 5 do if TableauDes[n] = m then inc(Compteur);
  until (m = 6) or (Compteur >= 3);
  TEST_BRELAN:=Compteur >= 3;
End;


Function TEST_CARRE : boolean;
(* RETOURNE true SI LES 5 DES FORMENT UN CARRE *)
(* MODIFIEE VERSION 2.20 *)
Var m,n,Compteur:byte;
Begin
  m:=0;
  repeat
    inc(m);
    Compteur:=0;
    for n:=1 to 5 do if TableauDes[n] = m then inc(Compteur);
  until (m = 6) or (Compteur >= 4);
  TEST_CARRE:=Compteur >= 4;
End;


Function TEST_FULL : boolean;
(* RETOURNE true SI LES 5 DES FORMENT UN FULL *)
(* MODIFIEE VERSION 2.20 *)
Var m,n,Triple,Compteur:byte;
Begin
  TEST_FULL:=false;
  m:=0;
  repeat
    inc(m); Triple:=m;
    Compteur:=0;
    for n:=1 to 5 do if TableauDes[n] = m then inc(Compteur);
  until (m = 6) or (Compteur = 3);
  if Compteur = 3
     then
       begin
         m:=0;
         repeat
           inc(m);
           Compteur:=0;
           for n:=1 to 5 do if (m <> Triple) and (TableauDes[n] = m) then inc(Compteur);
         until (m = 6) or (Compteur = 2);
         TEST_FULL:=Compteur = 2;
       end;
End;


Function TEST_PSUITE : boolean;
(* RETOURNE true SI LES 5 DES FORMENT UNE PETITE SUITE *)
(* MODIFIEE VERSION 2.20 *)
Var CopieTableauDes:TabDes;
    m,n,Sauve:byte;
    Erreur:boolean;
Begin
  CopieTableauDes:=TableauDes;
  TRI_DES;
  n:=1; Erreur:=false;
  repeat
    inc(n);
    Sauve:=TableauDes[n-1] + 1;
    if TableauDes[n] <> Sauve then begin Erreur:=true; m:=n; end;
  until (n = 5) or (Erreur);
  if not Erreur
     then
       TEST_PSUITE:=true
     else
       begin
         Sauve:=TableauDes[n];
         for n:=m to 4 do TableauDes[n]:=TableauDes[n+1];
         TableauDes[5]:=Sauve;
         n:=1; Erreur:=false;
         repeat
           inc(n);
           Sauve:=TableauDes[n-1] + 1;
           if TableauDes[n] <> Sauve then Erreur:=true;
         until (n = 4) or (Erreur);
         if not Erreur
            then
              TEST_PSUITE:=true
            else
              begin
                TRI_DES;
                n:=5; Erreur:=false;
                repeat
                  dec(n);
                  Sauve:=TableauDes[n+1]  - 1;
                  if TableauDes[n] <> Sauve then Erreur:=true;
                until (n = 2) or (Erreur);
                TEST_PSUITE:=not(Erreur);
              end;
       end;
  TableauDes:=CopieTableauDes;
End;


Function TEST_GSUITE : boolean;
(* RETOURNE true SI LES 5 DES FORMENT UNE GRANDE SUITE *)
(* MODIFIEE VERSION 2.20 *)
Var CopieTableauDes:TabDes;
Begin
  CopieTableauDes:=TableauDes;
  TRI_DES;
  TEST_GSUITE:=(TableauDes[2] = TableauDes[1] + 1) and (TableauDes[3] = TableauDes[2] + 1) and
               (TableauDes[4] = TableauDes[3] + 1) and (TableauDes[5] = TableauDes[4] + 1);
  TableauDes:=CopieTableauDes;
End;


Function TEST_YAHTZEE_SUP (Joueur : byte) : boolean;
(* RETOURNE true SI LES 5 DES FORMENT UN YAHTZEE ET S'IL S'AGIT D'UN YAHTZEE SUPPLEMENTAIRE *)
(* CREEE VERSION 2.20 *)
Begin
  TEST_YAHTZEE_SUP:=(TEST_YAHTZEE) and (FeuillePoints[Joueur,fp_Yahtzee,1] = 50) and
                    (FeuillePoints[Joueur,fp_Yahtzee,2] = 50) and (FeuillePoints[Joueur,fp_Yahtzee,3] = 50);
End;


Procedure FEUILLE_POINTS (Joueur:byte);
(* ECRITURE DU RESULTAT DANS LA FEUILLE DE POINTS PUIS PASSAGE AU JOUEUR SUIVANT.
   EVENTUELLEMENT, PERMET LA CORRECTION DE LA MARQUE. *)
Var xCourant,yCourant,Fond,Couleur,Haut,Bas:word;
    x,y,n,Ligne,Colonne:byte;
    Entree:char;
    FinMarque,Fin:boolean;
    PrimeYahtzee:word;
          Procedure ECRITURE_NOMBRE;
          (* ECRITURE D'UN NOMBRE DANS LA FEUILLE DE POINTS *)
          Begin
            txtback(black);
            case Colonne of
              1:txtcolour(ClrCol1);
              2:txtcolour(ClrCol2);
              3:txtcolour(ClrCol3);
            end;
            txtmove(x-1,y);
            if FeuillePoints[Joueur,Ligne,Colonne] = 65535
               then   (* EFFACEMENT DE LA MARQUE *)
                 txtwrite('   ')
               else   (* ECRITURE DE POINTS *)
                 txtnumwrite(FeuillePoints[Joueur,Ligne,Colonne],3);
          End;
          Procedure MARQUE (n:byte);
          (* MARQUAGE DES POINTS DANS LA FEUILLE DE POINTS.
             CHARGE Fin AVEC true SI LES POINTS PEUVENT ETRE INSCRITS DANS LA CASE CHOISIE. *)
          Begin
            if FeuillePoints[Joueur,Ligne,Colonne] = 65535
               then
                 begin
                   case Ligne of
                     fp_As..fp_Six:begin   (* SECTION SUPERIEURE *)
                                     if TEST_YAHTZEE_SUP(Joueur) then PrimeYahtzee:=300;
                                     FeuillePoints[Joueur,Ligne,Colonne]:=0;
                                     for n:=1 to 5 do
                                       if TableauDes[n] = Ligne then inc(FeuillePoints[Joueur,Ligne,Colonne],Ligne);
                                     Fin:=true;
                                     ECRITURE_NOMBRE;
                                   end;
                     fp_Brelan:if (TEST_BRELAN) or (TEST_YAHTZEE)
                                  then
                                    begin
                                      if TEST_YAHTZEE_SUP(Joueur) then PrimeYahtzee:=300;
                                      FeuillePoints[Joueur,Ligne,Colonne]:=0;
                                      for n:=1 to 5 do inc(FeuillePoints[Joueur,Ligne,Colonne],TableauDes[n]);
                                      Fin:=true;
                                      ECRITURE_NOMBRE;
                                    end;
                     fp_Carre:if (TEST_CARRE) or (TEST_YAHTZEE)
                                 then
                                   begin
                                     if TEST_YAHTZEE_SUP(Joueur) then PrimeYahtzee:=300;
                                     FeuillePoints[Joueur,Ligne,Colonne]:=0;
                                     for n:=1 to 5 do inc(FeuillePoints[Joueur,Ligne,Colonne],TableauDes[n]);
                                     Fin:=true;
                                     ECRITURE_NOMBRE;
                                   end;
                     fp_Full:if (TEST_FULL) or (TEST_YAHTZEE)
                                then
                                  begin
                                    if TEST_YAHTZEE_SUP(Joueur) then PrimeYahtzee:=300;
                                    FeuillePoints[Joueur,Ligne,Colonne]:=25;
                                    Fin:=true;
                                    ECRITURE_NOMBRE;
                                  end;
                     fp_PSuite:if TEST_PSUITE
                                  then
                                    begin
                                      FeuillePoints[Joueur,Ligne,Colonne]:=30;
                                      Fin:=true;
                                      ECRITURE_NOMBRE;
                                    end;
                     fp_GSuite:if TEST_GSUITE
                                  then
                                    begin
                                      FeuillePoints[Joueur,Ligne,Colonne]:=40;
                                      Fin:=true;
                                      ECRITURE_NOMBRE;
                                    end;
                     fp_Yahtzee:if TEST_YAHTZEE
                                   then
                                     begin
                                       PrimeYahtzee:=Colonne * 100;
                                       FeuillePoints[Joueur,Ligne,Colonne]:=50;
                                       Fin:=true;
                                       ECRITURE_NOMBRE;
                                     end;
                     fp_Chance:begin
                                 if TEST_YAHTZEE_SUP(Joueur) then PrimeYahtzee:=300;
                                 FeuillePoints[Joueur,Ligne,Colonne]:=0;
                                 for n:=1 to 5 do inc(FeuillePoints[Joueur,Ligne,Colonne],TableauDes[n]);
                                 Fin:=true;
                                 ECRITURE_NOMBRE;
                               end;
                   end;
                 end;
            PointsMarques:=Fin;
          End;
Begin
  MENU_TOUCHES_BOUTONS(2);
  xCourant:=windx; yCourant:=windy; Fond:=textbackgr; Couleur:=textcolour; txtgetcurssize(Haut,Bas);
  repeat
    PrimeYahtzee:=0;
    txtcurssize(0,memw[$0040:$0085] - 1);
    txtflush; mouseeventparams.me_modified:=false;
    x:=65; y:=2; Ligne:=1; Colonne:=1; Fin:=false; PointsMarques:=false;
    txtmove(x,y);
    if Souris then Void:=txtmousecurson;
    repeat
      if txtkeypressed
         then
           begin
             txtinput(Entree);
             case ord(Entree) of
               0:begin
                   txtinput(Entree);
                   case ord(entree) of
                     59:begin   (* F1 : REGLES DU JEU *)
                          if Souris then Void:=txtmousecursoff;
                          REGLES_DU_JEU;
                          if Souris then Void:=txtmousecurson;
                        end;
                     60:begin   (* F2 : RESULTATS ACTUELS *)
                          if Souris then Void:=txtmousecursoff;
                          SITUATION_ACTUELLE(Joueur);
                          if Souris then Void:=txtmousecurson;
                        end;
                     67:begin   (* F9 : NOUVELLE PARTIE *)
                          if Souris then Void:=txtmousecursoff;
                          FinPartie:=CONFIRMATION(1); if FinPartie then Fin:=true;
                          if Souris then Void:=txtmousecurson;
                        end;
                     68:begin   (* F10 : FIN DU PROGRAMME *)
                          if Souris then Void:=txtmousecursoff;
                          FinJeu:=CONFIRMATION(2); if FinJeu then Fin:=true;
                          if Souris then Void:=txtmousecurson;
                        end;
                     72:begin   (* FLECHE HAUT *)
                          case y of
                            2:begin y:=17; Ligne:=14; end;
                            11:begin y:=7; Ligne:=6; end;
                          else
                            dec(y); dec(Ligne);
                          end;
                          if Souris then Void:=txtmousecursoff; txtmove(x,y); if Souris then Void:=txtmousecurson;
                        end;
                     75:begin   (* FLECHE GAUCHE *)
                          if x = 65 then begin x:=75; Colonne:=3; end else begin dec(x,5); dec(Colonne); end;
                          if Souris then Void:=txtmousecursoff; txtmove(x,y); if Souris then Void:=txtmousecurson;
                        end;
                     77:begin   (* FLECHE DROITE *)
                          if x = 75 then begin x:=65; Colonne:=1; end else begin inc(x,5); inc(Colonne); end;
                          if Souris then Void:=txtmousecursoff; txtmove(x,y); if Souris then Void:=txtmousecurson;
                        end;
                     80:begin   (* FLECHE BAS *)
                          case y of
                            7:begin y:=11; Ligne:=8; end;
                            17:begin y:=2; Ligne:=1; end;
                          else
                            inc(y); inc(Ligne);
                          end;
                          if Souris then Void:=txtmousecursoff; txtmove(x,y); if Souris then Void:=txtmousecurson;
                        end;
                   end;
                 end;
               13:begin   (* ENTER : MARQUER LES POINTS *)
                    if Souris then Void:=txtmousecursoff;
                    MARQUE(n);   (* Fin EST POSITIONNE *)
                    if Souris then Void:=txtmousecurson;
                  end;
               48:begin   (* '0' : METTRE UN ZERO *)
                    if FeuillePoints[Joueur,Ligne,Colonne] = 65535
                       then
                         begin
                           FeuillePoints[Joueur,Ligne,Colonne]:=0;
                           Fin:=true;
                           if Souris then Void:=txtmousecursoff; ECRITURE_NOMBRE; if Souris then Void:=txtmousecurson;
                         end;
                  end;
               255:begin   (* ALT-255 : MESSAGE PERSONNEL *)
                     if Souris then Void:=txtmousecursoff;
                     MESSAGE_PERSONNEL;
                     if Souris then Void:=txtmousecurson;
                   end;
             end;
           end;
      if mouseeventparams.me_modified
         then
           with mouseeventparams do
             begin
               if (me_x in [64..67]) or (me_x in [69..72]) or (me_x in [74..77])
                  then
                    begin
                      case me_y of
                        2..7:begin   (* SECTION SUPERIEURE *)
                               Ligne:=me_y - 1; y:=me_y;
                               case me_x of
                                 64..67:begin x:=65; Colonne:=1; end;
                                 69..72:begin x:=70; Colonne:=2; end;
                                 74..77:begin x:=75; Colonne:=3; end;
                               end;
                               Void:=txtmousecursoff; MARQUE(n); txtmove(x,y); Void:=txtmousecurson;
                             end;
                        11..17:begin   (* SECTION INFERIEURE *)
                                 Ligne:=me_y - 3; y:=me_y;
                                 case me_x of
                                   64..67:begin x:=65; Colonne:=1; end;
                                   69..72:begin x:=70; Colonne:=2; end;
                                   74..77:begin x:=75; Colonne:=3; end;
                                 end;
                                 Void:=txtmousecursoff; MARQUE(n); txtmove(x,y); Void:=txtmousecurson;
                               end;
                      end;
                    end
                  else
                    if me_x in [28..45]
                       then
                         case me_y of
                           16:begin   (* BOUTON "REGLES DU JEU" *)
                                Void:=txtmousecursoff; REGLES_DU_JEU; Void:=txtmousecurson;
                              end;
                           17:begin   (* BOUTON "POINTS ACTUELS" *)
                                Void:=txtmousecursoff; SITUATION_ACTUELLE(Joueur); Void:=txtmousecurson;
                              end;
                           18:begin   (* BOUTON "NOUVELLE PARTIE" *)
                                Void:=txtmousecursoff;
                                FinPartie:=CONFIRMATION(1); if FinPartie then Fin:=true;
                                Void:=txtmousecurson;
                              end;
                           19:begin   (* BOUTON "QUITTER LE JEU" *)
                                Void:=txtmousecursoff;
                                FinJeu:=CONFIRMATION(2); if FinJeu then Fin:=true;
                                Void:=txtmousecurson;
                              end;
                         end;
               me_modified:=false;
             end;
    until Fin;
    inc(TableauPrimes[Joueur],PrimeYahtzee);
    if Souris then Void:=txtmousecursoff;
    if (FinPartie) or (FinJeu)
       then
         FinMarque:=true
       else
         begin
           FinMarque:=FIN_MARQUE;   (* BOITE DE DIALOGUE DE PASSAGE AU JOUEUR SUIVANT OU DE CORRECTION DE LA MARQUE *)
           if not FinMarque
              then   (* EFFACEMENT DE LA MARQUE ET ON RECOMMENCE *)
                begin
                  dec(TableauPrimes[Joueur],PrimeYahtzee);
                  FeuillePoints[Joueur,Ligne,Colonne]:=65535; ECRITURE_NOMBRE;
                  PointsMarques:=false;
                end;
         end;
  until FinMarque;
  txtback(Fond); txtcolour(Couleur); txtmove(xCourant,yCourant); txtcurssize(Haut,Bas);
End;


Procedure JOUER_COUP (Joueur:byte);
(* UN COUP COMPLET : 3 LANCERS DE DES + LA MARQUE *)
(* MODIFIE VERSION 2.20 *)
Var n,y:byte;
    Fin:boolean;
Begin
  (* LANCER DES DES *)
  for n:=1 to 5 do repeat TableauDes[n]:=random(7); until (TableauDes[n]>=1) and (TableauDes[n]<=6);
  (* TRI DES DES PAR ORDRE CROISSANT *)
  TRI_DES;
  (* AFFICHAGE DES DES *)
  y:=1; for n:=1 to 5 do begin AFFICHAGE_DE(0,y,TableauDes[n]); inc(y,5); end;
  (* TRAITEMENT DES DES *)
  for n:=1 to 5 do TableauGarder[n]:=false;
  n:=0;
  repeat
    inc(n);
    Fin:=TRAITEMENT_DES(Joueur);
    if not Fin then if Tricher then LANCER_YAHTZEE else RELANCER;
  until (n = 2) or (Fin);
  (* ECRITURE DANS LA FEUILLE DE POINTS ET PASSAGE AU JOUEUR SUIVANT *)
  if (not FinPartie) and (not FinJeu) then FEUILLE_POINTS(Joueur);
End;


Procedure AFFICHAGE_TOTAUX (Joueur:byte);
(* CALCUL ET AFFICHAGE DES TOTAUX DE LA FEUILLE DE POINTS *)
(* MODIFIEE VERSION 2.20 *)
Var Ligne,Colonne,Clr1,Clr2:byte;
    x,Haut,Bas:word;
    Entree:char;
Begin
  txtgetcurssize(Haut,Bas); txtcursoff;
  case ModeEcran of
    ModeMono:begin Clr1:=white; Clr2:=white; end;
    ModeGris:begin Clr1:=lightcyan; Clr2:=white; end;
    ModeCouleur:begin Clr1:=lightgreen; Clr2:=lightcyan; end;
  end;
  FeuillePoints[Joueur,fp_Total,1]:=0;
  for Colonne:=1 to 3 do
    begin
      x:=64 + (Colonne - 1) * 5;
      (* TOTAL SECTION SUPERIEURE *)
      FeuillePoints[Joueur,fp_TotalSup,Colonne]:=0;
      for Ligne:=1 to 6 do inc(FeuillePoints[Joueur,fp_TotalSup,Colonne],FeuillePoints[Joueur,Ligne,Colonne]);
      if FeuillePoints[Joueur,fp_TotalSup,Colonne]>=63 then inc(FeuillePoints[Joueur,fp_TotalSup,Colonne],35);
      (* TOTAL SECTION INFERIEURE *)
      FeuillePoints[Joueur,fp_TotalInf,Colonne]:=0;
      for Ligne:=8 to 14 do inc(FeuillePoints[Joueur,fp_TotalInf,Colonne],FeuillePoints[Joueur,Ligne,Colonne]);
      (* TOTAL DE LA COLONNE *)
      FeuillePoints[Joueur,fp_TotalCol,Colonne]:=(FeuillePoints[Joueur,fp_TotalSup,Colonne] +
                                                  FeuillePoints[Joueur,fp_TotalInf,Colonne]) * Colonne;
      (* TOTAL FEUILLE DE POINTS *)
      inc(FeuillePoints[Joueur,fp_Total,1],FeuillePoints[Joueur,fp_TotalCol,Colonne]);
      (* AFFICHAGE TOTAUX COLONNE *)
      txtback(black); txtcolour(Clr1);
      txtmove(x+1,9); txtnumwrite(FeuillePoints[Joueur,fp_TotalSup,Colonne],0);
      txtmove(x+1,19); txtnumwrite(FeuillePoints[Joueur,fp_TotalInf,Colonne],0);
      txtmove(x,21); txtnumwrite(FeuillePoints[Joueur,fp_TotalCol,Colonne],4);
    end;
  (* AFFICHAGE TOTAL *)
  txtcolour(yellow);
  txtmove(68,23); txtnumwrite(FeuillePoints[Joueur,fp_Total,1],5);
  txtcurssize(Haut,Bas);
  (* PASSAGE AU JOUEUR SUIVANT *)
  BOUTON_OK;
End;


BEGIN   (* PROGRAMME PRINCIPAL *)
  INITIALISATION_PROGRAMME;
  if Carte in [vc_Mda,vc_Hercules]
     then
       INTRODUCTION_TEXTE
     else
       if not INTRODUCTION_GRAPH then INTRODUCTION_TEXTE;
  FinJeu:=false; randomize;
  repeat
    (* INITIALISATIONS *)
    for Joueur:=1 to 9 do
      begin
        TableauPrimes[Joueur]:=0; NomsJoueurs[Joueur]:='';
        for Ligne:=1 to 17 do for Colonne:=1 to 3 do FeuillePoints[Joueur,Ligne,Colonne]:=65535;
      end;
    Tricher:=false;
    txtback(black); txtcolour(lightgrey); txtclear;
    NbJoueurs:=ENCODAGE_JOUEURS;   (* LECTURE DU NOMBRE DE JOUEURS ET DU NOM DES JOUEURS *)
    if NbJoueurs > 0
       then
         begin
           Coup:=0; FinPartie:=false;
           repeat
             inc(Coup); Joueur:=0;
             repeat
               inc(Joueur);
               PointsMarques:=false;
               AFFICHAGE_ECRAN_JEU(Joueur);
               JOUER_COUP(Joueur);
               if (Coup = 39) and (not FinPartie) and (not FinJeu) then AFFICHAGE_TOTAUX(Joueur);
             until (Joueur = NbJoueurs) or (FinPartie) or (FinJeu);
           until (Coup = 39) or (FinPartie) or (FinJeu);
           if (not FinPartie) and (not FinJeu)
              then
                begin
                  RESUME_FINAL; SAUVETAGE_CLASSEMENTS;
                end;
         end
       else
         FinJeu:=true;
  until FinJeu;
  SORTIE_PROGRAMME;
END.
