
UNIT YAH_DECL;

(* DECLARATIONS GLOBALES POUR LE PROGRAMME YAHTZEE VERSION 2.20.
   INITIALISATIONS.
   MESSAGES AU BAS DE L'ECRAN, AVERTISSEMENTS ET MESSAGES D'ERREUR *)

INTERFACE

{$I-}

Uses TXT,        (* GESTION MODE TEXTE - VERSION 2.00 *)
     GRAPH,      (* AFFICHAGES GRAPHIQUES DE L'INTRO *)
     YAH_HARD;   (* GESTION SOURIS ET RECONNAISSANCE DU HARDWARE *)


Type Str15 = string[15];
     TabGen = array[1..9,1..17,1..3] of word;   (* FEUILLES DE POINTS DES 9 JOUEURS *)
     TabDes = array[1..5] of byte;              (* LES 5 DES *)
     TabGarder = array[1..5] of boolean;        (* GARDER OU NON LES 5 DES *)
     TabNoms = array[1..9] of Str15;            (* NOMS DES JOUEURS *)
     TabPrimesYah = array[1..9] of word;        (* PRIMES YAHTZEE TOTALES *)
     Enreg = record   (* ENREGISTREMENT FICHIER DE CLASSEMENT *)
               NomJoueur,Date:Str15;
               Total,TotalPrimes:word;
             end;
     TabEnreg = array[1..20] of Enreg;          (* TABLEAU DE CLASSEMENT *)
     TabMessage = array[1..38] of string[80];   (* MESSAGE PERSONNEL *)


Const (* MODES DE GESTION DES COULEURS A L'ECRAN *)
      ModeMono = 0;
      ModeGris = 1;
      ModeCouleur = 2;
      (* DESSIN DES DES *)
      LigneFondDe : string[7] = '       ';
      BandeNoireDe : string[7] = '';
      PointDe : char = '';
      (* ORDONNEES DANS LES FEUILLES DE POINTS  *)
      fp_As = 1;
      fp_Deux = 2;
      fp_Trois = 3;
      fp_Quatre = 4;
      fp_Cinq = 5;
      fp_Six = 6;
      fp_TotalSup = 7;
      fp_Brelan = 8;
      fp_Carre = 9;
      fp_Full = 10;
      fp_PSuite = 11;
      fp_GSuite = 12;
      fp_Yahtzee = 13;
      fp_Chance = 14;
      fp_TotalInf = 15;
      fp_TotalCol = 16;
      fp_Total = 17;
      (* MESSAGE PERSONNEL CRYPTE *)
      Message : TabMessage = ('ftttfftttfftttffttt',
                              'ffffffffЪfffffffff',
                              'ffmfffμtfffmfmfff',
                              'fffrfffmfffffff',
                              'fffmffrffrffҺttt',
                              'fffffffκfmfffrfffrff',
                              'fffrffffȲȼrffЭffttt',
                              'fffffffffffffμrffft',
                              'fffffmffffffffȺffμt',
                              'fffffmffmt',
                              'fffffйfmffйfmfȫrfmffffftf',
                              'ȩȳrffffffffffffffr',
                              'fffгfȺffffЭrffwfȩf',
                              'frffffȺfȸfffffmff',
                              'fmffffffffȶt',
                              'fffffffffffmfffȷfffff',
                              'fmffffrffȭѹffffҺt',
                              'fmfft',
                              'ffffffμfmffftfrfffffffff',
                              'fȫfffffmffffff',
                              'ɩffȸtfrffffffftf',
                              'mfffmȩfffȫfrfmrffmfff',
                              'ft',
                              'ffffffnffgofffffйffrffff',
                              'κrffffffmffȫrfffmȲ',
                              'fffffmfffffٲffrff',
                              'fmffffȬȹtffmffft',
                              'ffffffffmffrfmtfmffff',
                              'fffffffffffffmȩfȶкf',
                              'fffft',
                              'fffffffrfffȧfftfȴȸrff',
                              'fffffffйffsfff',
                              'ffmffffȺfmfffft',
                              'ffffffmffmfffffffȹfffmf',
                              'ffffȹfffѼfffff',
                              'Ȩfftffrfmffffffmfܲt',
                              'fffffffrft',
                              'ffffffmt');


Var (* VARIABLES LIEES AU HARDWARE *)
    Void : boolean;   (* RESULTATS IGNORES DE FONCTIONS TXT 3.00 *)
    Souris : boolean;   (* INDIQUE SI GESTION SOURIS *)
    ModeEcran : byte;   (* MODE DE GESTION DES COULEURS A L'ECRAN *)
    Carte,Moniteur : byte;   (* CARTE VIDEO ET MONITEUR INSTALLES *)
    BufferSouris : pointer;   (* @ SAUVETAGE PARAMETRES INITIAUX SOURIS *)
    TailleBufferSouris : word;   (* TAILLE BUFFER SAUVEGARDE PARAMETRES SOURIS *)
    CurseurHaut,CurseurBas : word;   (* TAILLE DU CURSEUR *)
    (* VARIABLES GENERALES *)
    FondBouton,ClrBouton,ClrCol1,ClrCol2,ClrCol3 : byte;
    FondGarder,ClrGarder,FondRelancer,ClrRelancer,FondDeGarder,ClrDeGarder : byte;
    Buffer : Enreg;   (* BUFFER FICHIER DE CLASSEMENT *)
    Fichier : file of Enreg;   (* FICHIER DE CLASSEMENT *)
    NomFichier : string;   (* NOM DU FICHIER DE CLASSEMENT EN COURS *)
    (* VARIABLES DIRECTEMENT LIEES AU JEU *)
    NbJoueurs : byte;   (* NOMBRE DE JOUEURS *)
    NomsJoueurs : TabNoms;   (* NOMS DES JOUEURS *)
    TableauDes : TabDes;   (* MONTANT DES 5 DES *)
    TableauGarder : TabGarder;   (* INDIQUE SI CHAQUE DE DOIT ETRE GARDE OU REJOUE *)
    FeuillePoints : TabGen;   (* FEUILLES DE POINTS DES 9 JOUEURS *)
    TableauPrimes : TabPrimesYah;   (* PRIMES YAHTZEE *)
    Classement1,Classement2 : TabEnreg;   (* CLASSEMENT SANS ET AVEC PRIMES YAHTZEE *)
    Coup,Joueur,Ligne,Colonne : byte;
    FinJeu,FinPartie,Tricher,PointsMarques : boolean;   (* SORTIE DU JEU / NOUVELLE PARTIE / TRICHER / POINTS MARQUES *)


Function ERREUR_HEAP (Taille:word) : integer;
   (* EMPECHE UNE ERREUR FATALE SI ERREUR ALLOCATION MEMOIRE *)
Procedure INITIALISATION_PROGRAMME;
   (* INITIALISATION DES VARIABLES GLOBALES DU PROGRAMME ET DE L'UNITE TXT *)
Procedure INITIALISATION_SOURIS;
   (* DETECTION, SAUVETAGE DRIVER ET CHARGEMENT GESTIONNAIRE EVENEMENTS SOURIS *)
Procedure SORTIE_PROGRAMME;
   (* RESTAURATION DE L'ENVIRONNEMENT EN FIN DE PROGRAMME *)
Function INTRODUCTION_GRAPH : boolean;
   (* AFFICHAGE DU TITRE EN MODE GRAPHIQUE 640*200 ET INITIALISATION DU DRIVER DE SOURIS *)
Procedure INTRODUCTION_TEXTE;
   (* AFFICHAGE DU TITRE EN MODE TEXTE ET INITIALISATION DU DRIVER DE SOURIS *)


IMPLEMENTATION

{$F+}
Function ERREUR_HEAP (Taille:word) : integer;
(* EMPECHE UNE ERREUR FATALE SI ERREUR ALLOCATION MEMOIRE *)
Begin
  ERREUR_HEAP:=1;   (* new ET getmem RENVOIENT nil SI ERREUR ALLOCATION *)
End;
{$F-}


Procedure INITIALISATION_PROGRAMME;
(* INITIALISATION DES VARIABLES GLOBALES DU PROGRAMME ET DE L'UNITE TXT *)
Var ResultatInit:byte;
    Carte2,Moniteur2:byte;
Begin
  txtavoidbreak;
  txtinit(ResultatInit);
  (* MODE D'ECRAN (COULEUR, MONOCHROME, NIVEAUX DE GRIS) *)
  if txtgetvideosystems(Carte,Moniteur,Carte2,Moniteur2)
     then
       begin
         if Carte in [vc_Mda,vc_Hercules]
            then
              ModeEcran:=ModeMono
            else
              if Moniteur in [vm_Mono,vm_MonoAnalog] then ModeEcran:=ModeGris else ModeEcran:=ModeCouleur;
       end
     else
       ModeEcran:=ModeMono;   (* PAR DEFAUT, MODE MONOCHROME *)
(*
ModeEcran:=ModeMono; Carte:=vc_Hercules;
*)
  if ModeEcran = ModeMono then txtmode(7) else txtmode(3);
  (* COULEURS D'AFFICHAGE *)
  case ModeEcran of
    ModeMono:begin
               FondBouton:=lightgrey; ClrBouton:=black;
               ClrCol1:=white; ClrCol2:=white; ClrCol3:=white;
               FondGarder:=lightgrey; ClrGarder:=white; FondRelancer:=black; ClrRelancer:=lightgrey;
               FondDeGarder:=lightgrey; ClrDeGarder:=black;
             end;
    ModeGris:begin
               FondBouton:=lightgrey; ClrBouton:=black;
               ClrCol1:=brown; ClrCol2:=lightgrey; ClrCol3:=white;
               FondGarder:=brown; ClrGarder:=white; FondRelancer:=black; ClrRelancer:=lightgrey;
               FondDeGarder:=brown; ClrDeGarder:=black;
             end;
    ModeCouleur:begin
                  FondBouton:=cyan; ClrBouton:=yellow;
                  ClrCol1:=yellow; ClrCol2:=lightred; ClrCol3:=lightmagenta;
                  FondGarder:=magenta; ClrGarder:=yellow; FondRelancer:=black; ClrRelancer:=lightgrey;
                  FondDeGarder:=cyan; ClrDeGarder:=black;
                end;
  end;
  (* CURSEUR *)
  txtgetcurssize(CurseurHaut,CurseurBas); txtcursoff;
  (* GESTION D'ERREURS DU TAS *)
  heaperror:=@ERREUR_HEAP;
End;


Procedure INITIALISATION_SOURIS;
(* DETECTION, SAUVETAGE DRIVER ET CHARGEMENT GESTIONNAIRE EVENEMENTS SOURIS *)
Var StatutSouris:integer;
    MasqueAnd,MasqueXor:word;
Begin
  Souris:=true;
  (* DETECTION *)
  if txtdetectmouse
     then
       begin
         (* SAUVETAGE DES PARAMETRES DU DRIVER ET INITIALISATION *)
         TailleBufferSouris:=txtmousesavebuffersize;
         getmem(BufferSouris,TailleBufferSouris);
         if BufferSouris <> nil
            then
              begin
                if (txtsavemouse(BufferSouris)) and (txtinitmouse(StatutSouris))
                   then
                     begin
                       (* CHARGEMENT DU GESTIONNAIRE D'EVENEMENTS *)
                       if txtinstallmouseeventhandler(me_Normal,@ EVENTHND,me_LButtonDown)
                          then
                            begin
                              (* DEFINITION DU CURSEUR SOURIS *)
                              Void:=txtmousecursormasks(mc_Keep,0,mc_Invert,0,MasqueAnd,MasqueXor);
                              if not txtmousecursor(mc_Log,MasqueAnd,MasqueXor) then Souris:=false;
                            end
                          else
                            Souris:=false;
                     end
                   else
                     Souris:=false;
              end
            else
              Souris:=false;
       end
     else
       Souris:=false;
End;


Procedure SORTIE_PROGRAMME;
(* RESTAURATION DE L'ENVIRONNEMENT EN FIN DE PROGRAMME *)
Begin
  if Souris then Void:=txtloadmouse(BufferSouris);
  release(heaporg);
  txtcurssize(CurseurHaut,CurseurBas);
  txtallowbreak;
  txtrestoremode;
  writeln('LPJJl vous salue bien bas...');
  writeln('');
End;


Procedure DESSIN_LETTRE_TITRE (Lettre:char; x,y:word);
(* DESSIN D'UNE LETTRE DU MOT "YAHTZEE" (EN MODE GRAPHIQUE 640 * 200).
   (x,y) = COORDONNEES HAUT-GAUCHE DE LA LETTRE. *)
(* MODIFIEE VERSION 2.20 *)
Begin
  case Lettre of
    'A':begin
          line(x+18,y,x+18,y);
          line(x+17,y+1,x+18,y+1);
          line(x+15,y+2,x+16,y+2); line(x+18,y+2,x+19,y+2);
          line(x+13,y+3,x+15,y+3); line(x+19,y+3,x+20,y+3);
          line(x+11,y+4,x+14,y+4); line(x+19,y+4,x+21,y+4);
          line(x+10,y+5,x+13,y+5); line(x+19,y+5,x+23,y+5);
          line(x+9,y+6,x+12,y+6); line(x+20,y+6,x+24,y+6);
          line(x+8,y+7,x+11,y+7); line(x+20,y+7,x+25,y+7);
          line(x+7,y+8,x+10,y+8); line(x+21,y+8,x+26,y+8); line(x+29,y+8,x+30,y+8);
          line(x+6,y+9,x+10,y+9); line(x+21,y+9,x+28,y+9);
          line(x+5,y+10,x+9,y+10); line(x+12,y+10,x+29,y+10);
          line(x+4,y+11,x+31,y+11);
          line(x+3,y+12,x+15,y+12); line(x+24,y+12,x+33,y+12);
          line(x+3,y+13,x+8,y+13); line(x+25,y+13,x+35,y+13);
          line(x+2,y+14,x+8,y+14); line(x+26,y+14,x+37,y+14);
          line(x+2,y+15,x+8,y+15); line(x+27,y+15,x+39,y+15);
          line(x+1,y+16,x+8,y+16); line(x+29,y+16,x+36,y+16);
          line(x+1,y+17,x+8,y+17); line(x+31,y+17,x+35,y+17);
          line(x+1,y+18,x+3,y+18); line(x+33,y+18,x+35,y+18);
          line(x+1,y+19,x+1,y+19); line(x+35,y+19,x+35,y+19);
        end;
    'E':begin
          line(x,y,x+2,y); line(x+5,y,x+5,y);
          line(x+4,y+1,x+4,y+1); line(x+6,y+1,x+29,y+1);
          line(x+3,y+2,x+4,y+2); line(x+12,y+2,x+30,y+2);
          line(x+2,y+3,x+4,y+3); line(x+20,y+3,x+31,y+3);
          line(x,y+4,x+4,y+4);
          line(x+1,y+5,x+7,y+5);
          line(x,y+6,x+4,y+6); line(x+7,y+6,x+14,y+6);
          line(x,y+7,x+4,y+7); line(x+11,y+7,x+22,y+7);
          line(x,y+8,x+5,y+8); line(x+16,y+8,x+23,y+8);
          line(x,y+9,x+6,y+9); line(x+21,y+9,x+24,y+9);
          line(x+1,y+10,x+8,y+10);
          line(x+1,y+11,x+10,y+11);
          line(x+2,y+12,x+13,y+12);
          line(x+3,y+13,x+17,y+13);
          line(x+4,y+14,x+23,y+14); line(x+33,y+14,x+39,y+14);
          line(x+5,y+15,x+37,y+15);
          line(x+7,y+16,x+35,y+16);
          line(x+10,y+17,x+33,y+17);
          line(x+14,y+18,x+31,y+18);
          line(x+20,y+19,x+28,y+19);
        end;
    'H':begin
          line(x,y,x,y); line(x+22,y,x+22,y);
          line(x+1,y+1,x+1,y+1); line(x+22,y+1,x+23,y+1);
          line(x+2,y+2,x+2,y+2); line(x+22,y+2,x+24,y+2);
          line(x+2,y+3,x+3,y+3); line(x+21,y+3,x+26,y+3);
          line(x+2,y+4,x+4,y+4); line(x+21,y+4,x+29,y+4);
          line(x+3,y+5,x+4,y+5); line(x+21,y+5,x+28,y+5);
          line(x+1,y+6,x+5,y+6); line(x+21,y+6,x+27,y+6);
          line(x+4,y+7,x+6,y+7); line(x+21,y+7,x+26,y+7);
          line(x+4,y+8,x+9,y+8); line(x+21,y+8,x+26,y+8);
          line(x+4,y+9,x+7,y+9); line(x+10,y+9,x+16,y+9); line(x+21,y+9,x+25,y+9);
          line(x+4,y+10,x+7,y+10); line(x+12,y+10,x+27,y+10);
          line(x+4,y+11,x+7,y+11); line(x+17,y+11,x+27,y+11);
          line(x+3,y+12,x+7,y+12); line(x+22,y+12,x+28,y+12);
          line(x+2,y+13,x+7,y+13); line(x+22,y+13,x+25,y+13);
          line(x+1,y+14,x+7,y+14); line(x+23,y+14,x+25,y+14);
          line(x,y+15,x+7,y+15); line(x+24,y+15,x+26,y+15);
          line(x+2,y+16,x+7,y+16); line(x+25,y+16,x+26,y+16);
          line(x+5,y+17,x+7,y+17); line(x+26,y+17,x+27,y+17);
          line(x+7,y+18,x+7,y+18); line(x+27,y+18,x+28,y+18);
          line(x+7,y+19,x+7,y+19); line(x+28,y+19,x+28,y+19);
        end;
    'T':begin
          line(x+5,y,x+6,y); line(x+17,y,x+17,y); line(x+25,y,x+27,y);
          line(x+4,y+1,x+24,y+1);
          line(x+3,y+2,x+19,y+2);
          line(x+2,y+3,x+15,y+3);
          line(x,y+4,x+7,y+4); line(x+13,y+4,x+15,y+4);
          line(x+13,y+5,x+15,y+5);
          line(x+12,y+6,x+15,y+6);
          line(x+12,y+7,x+15,y+7);
          line(x+11,y+8,x+15,y+8);
          line(x+10,y+9,x+15,y+9);
          line(x+10,y+10,x+15,y+10);
          line(x+10,y+11,x+15,y+11);
          line(x+10,y+12,x+16,y+12);
          line(x+10,y+13,x+16,y+13);
          line(x+10,y+14,x+17,y+14);
          line(x+10,y+15,x+18,y+15);
          line(x+11,y+16,x+19,y+16);
          line(x+11,y+17,x+17,y+17);
          line(x+12,y+18,x+14,y+18);
          line(x+12,y+19,x+12,y+19);
        end;
    'Y':begin
          line(x+6,y,x+7,y); line(x+30,y,x+31,y);
          line(x+3,y+1,x+7,y+1); line(x+28,y+1,x+32,y+1);
          line(x+1,y+2,x+8,y+2); line(x+26,y+2,x+35,y+2);
          line(x+2,y+3,x+9,y+3); line(x+24,y+3,x+36,y+3);
          line(x+4,y+4,x+10,y+4); line(x+22,y+4,x+32,y+4);
          line(x+6,y+5,x+12,y+5); line(x+21,y+5,x+29,y+5);
          line(x+8,y+6,x+14,y+6); line(x+20,y+6,x+27,y+6);
          line(x+11,y+7,x+16,y+7); line(x+19,y+7,x+25,y+7);
          line(x+14,y+8,x+23,y+8);
          line(x+17,y+9,x+21,y+9);
          line(x+16,y+10,x+20,y+10); line(x+22,y+10,x+22,y+10);
          line(x+16,y+11,x+19,y+11);
          line(x+15,y+12,x+17,y+12);
          line(x+15,y+13,x+16,y+13);
          line(x+14,y+14,x+15,y+14);
          line(x+14,y+15,x+14,y+15);
          line(x+13,y+16,x+13,y+19);
        end;
    'Z':begin
          line(x+10,y,x+29,y); line(x+32,y,x+35,y);
          line(x+1,y+1,x+21,y+1); line(x+29,y+1,x+31,y+1);
          line(x+4,y+2,x+14,y+2); line(x+26,y+2,x+28,y+2);
          line(x+6,y+3,x+10,y+3); line(x+23,y+3,x+25,y+3);
          line(x+8,y+4,x+8,y+4); line(x+21,y+4,x+23,y+4);
          line(x+18,y+5,x+21,y+5);
          line(x+16,y+6,x+19,y+6);
          line(x+14,y+7,x+18,y+7);
          line(x+13,y+8,x+17,y+8);
          line(x+11,y+9,x+16,y+9);
          line(x+10,y+10,x+15,y+10);
          line(x+8,y+11,x+14,y+11);
          line(x+7,y+12,x+13,y+12);
          line(x+6,y+13,x+12,y+13);
          line(x+5,y+14,x+11,y+14);
          line(x+4,y+15,x+11,y+15); line(x+22,y+15,x+34,y+15);
          line(x+3,y+16,x+11,y+16); line(x+15,y+16,x+38,y+16);
          line(x+2,y+17,x+37,y+17);
          line(x+3,y+18,x+12,y+18); line(x+24,y+18,x+36,y+18);
          line(x,y+19,x+2,y+19); line(x+33,y+19,x+35,y+19);
        end;
  end;
End;


Function INTRODUCTION_GRAPH : boolean;
(* AFFICHAGE DU TITRE EN MODE GRAPHIQUE 640*200 ET INITIALISATION DU DRIVER SOURIS.
   RETOURNE true SI TOUT S'EST BIEN PASSE AU NIVEAU GRAPHISME. *)
(* MODIFIEE VERSION 2.20 *)
Var Pilote,ModeVideo:integer;
    Ok:boolean;
    Entree:char;
Begin
  detectgraph(Pilote,ModeVideo);
  if graphresult = 0
     then
       begin
         Ok:=true;
         case Pilote of
           1,2,8:ModeVideo:=2;   (* CGA --> CGAHi / MCGA --> MCGAMed / ATT400 --> ATT400Med *)
           3,4,9:ModeVideo:=0;   (* EGA --> EGALo / EGA64 --> EGA64Lo / VGA --> VGALo *)
         else
           Ok:=false;
         end;
         if Ok
            then
              begin
                initgraph(Pilote,ModeVideo,'');
                if graphresult = 0
                   then
                     begin
                       setlinestyle(solidln,0,1);
                       DESSIN_LETTRE_TITRE('Y',195,90); DESSIN_LETTRE_TITRE('A',225,90); DESSIN_LETTRE_TITRE('H',270,90);
                       DESSIN_LETTRE_TITRE('T',305,90); DESSIN_LETTRE_TITRE('Z',335,90); DESSIN_LETTRE_TITRE('E',375,90);
                       DESSIN_LETTRE_TITRE('E',415,90);
                       settextstyle(defaultfont,horizdir,1); settextjustify(centertext,centertext);
                       outtextxy(319,125,'Version 2.20');
                       outtextxy(319,195,'LPJJl Software, Belgium, 1995-1996');
                       settextstyle(defaultfont,horizdir,2);
                       outtextxy(317,69,'TRIPLE'); outtextxy(319,70,'TRIPLE'); outtextxy(321,71,'TRIPLE');
                       line(4,4,635,4); line(4,4,4,195); line(635,4,635,195);
                       line(4,195,177,195); line(462,195,635,195);
                       settextstyle(defaultfont,horizdir,1);
                       outtextxy(319,160,'(Un instant S.V.P)');
                       INITIALISATION_SOURIS;
                       setcolor(black); outtextxy(319,160,'');
                       txtflush; txtinput(Entree); txtflush;
                       closegraph;
                     end
                   else
                     Ok:=false;
              end;
       end
     else
       Ok:=false;
  INTRODUCTION_GRAPH:=Ok;
End;


Procedure INTRODUCTION_TEXTE;
(* AFFICHAGE DU TITRE EN MODE TEXTE ET INITIALISATION DU DRIVER DE SOURIS *)
(* CREEE VERSION 2.20 *)
Var y,Haut,Bas:word;
    Entree:char;
Begin
  txtgetcurssize(Haut,Bas); txtcursoff;
  txtback(black);
  txtcolour(lightgrey);
  txtmove(26,2);  txtwrite('            ');
  txtmove(26,3);  txtwrite('       ');
  txtmove(26,4);  txtwrite('۰۰۱۰۱  ۰');
  txtmove(26,5);  txtwrite(' ۱۱ ۱۱ ۱  ۱');
  txtmove(26,6);  txtwrite(' ۱ ۱  ۱۰');
  txtmove(26,7);  txtwrite(' ۱ ۱ ۱۱۱   ۱۱');
  txtmove(26,8);  txtwrite('            ');
  txtcolour(white);
  txtmove(2,10); txtwrite('                                   ');
  txtmove(2,11); txtwrite('                                         ');
  txtmove(2,12); txtwrite('                                            ');
  txtmove(2,13); txtwrite('                                        ');
  txtmove(2,14); txtwrite('                                                ');
  txtmove(2,15); txtwrite('                                       ');
  txtmove(34,18); txtwrite('Version 2.20');
  txtmove(0,0); txtwrite('Ŀ');
  for y:=1 to 23 do
    begin
      txtmove(0,y); txtwrite(''); txtmove(79,y); txtwrite('');
    end;
  txtmove(0,24); txtwrite('');
  txtmove(22,24); txtwrite(' LPJJl Software, Belgium, 1995-1996 ');
  txtcolour(lightgrey + blink); txtmove(31,21); txtwrite('(Un instant S.V.P)');
  INITIALISATION_SOURIS;
  txtback(black); txtmove(31,21); txtwrite('                  ');
  txtflush; txtinput(Entree); txtflush;
  txtcurssize(Haut,Bas);
End;


END.
