
UNIT YAH_DLGS;

(* BOITES DE DIALOGUE POUR LE PROGRAMME YAHTZEE 2.20 *)

INTERFACE

Uses TXT,YAH_HARD,YAH_DECL,YAH_HELP;

Function ENCODAGE_JOUEURS : byte;
   (* DEMANDE DU NOMBRE DE JOUEURS ET ENCODAGE DE LEURS NOMS RESPECTIFS *)
Function FIN_MARQUE : boolean;
   (* APRES LA MARQUE DANS LA FEUILLE DE POINTS, DEMANDE SI CORRIGER LA MARQUE OU
      SI PASSAGE AU JOUEUR SUIVANT OU SI FIN DE PARTIE OU SI QUITTER LE JEU *)
Function CONFIRMATION (n:byte) : boolean;
   (* BOITE DE DIALOGUE DE CONFIRMATION DE COMMANDE *)
Procedure SITUATION_ACTUELLE (JoueurCourant:byte);
   (* AFFICHAGE DES POINTS ACTUELS DE TOUS LES JOUEURS (PRIMES COMPRISES) *)
Procedure RESUME_FINAL;
   (* AFFICHAGE DES POINTS DE TOUS LES JOUEURS : SANS LES PRIMES, PRIMES, TOTAL *)
Procedure BOUTON_OK;
   (* BOUTON "OK" SIMPLE A LA PLACE DES MENUS TRAITEMENT DES OU ECRITURE FEUILLE DE POINTS *)
Function MESSAGE_ERREUR (Erreur:byte) : boolean;
   (* AFFICHAGE MESSAGE D'ERREUR DISQUE ET RECOMMENCER/ABANDONNER *)
Procedure INSERER_DISQUETTE;
   (* BOITE DE DIALOGUE INSERTION DISQUETTE AVEC BOUTON "OK" *)
Procedure AFFICHAGE_CLASSEMENTS;
   (* AFFICHAGE DES 2 CLASSEMENTS (SANS ET AVEC PRIMES) *)


IMPLEMENTATION

Function ENCODAGE_JOUEURS : byte;
(* DEMANDE DU NOMBRE DE JOUEURS ET ENCODAGE DE LEURS NOMS RESPECTIFS.
   RETOURNE LE NOMBRE DE JOUEURS (0 SI ANNULER). *)
(* CREEE VERSION 2.20 *)
Var xCourant,yCourant,FondCourant,CouleurCourante:word;
    Fond1,Normal,Fond2,Brillant,Res,OptionLecture:word;
    Image:videosave;
    NbJoueurs,Rubrique:byte;
    Chaine:string;
    Entree:char;
    Ok,Fin:boolean;
          Procedure RUBRIQUE_ALLUMEE;
          (* MISE EN SURBRILLANCE D'UNE RUBRIQUE *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              1:begin txtmove(53,6); txtattrib(1); end;
              2..10:begin txtmove(38,Rubrique + 6); txtattrib(15); end;
              11:begin txtmove(26,18); txtattrib(11); end;
              12:begin txtmove(43,18); txtattrib(11); end;
            end;
          End;
          Procedure RUBRIQUE_ETEINTE;
          (* FIN DE LA MISE EN SURBRILLANCE D'UNE RUBRIQUE *)
          Begin
            txtback(Fond1);
            case Rubrique of
              1:begin txtcolour(Brillant); txtmove(53,6); txtattrib(1); end;
              2..10:begin txtcolour(Brillant); txtmove(38,Rubrique + 6); txtattrib(15); end;
              11:begin txtcolour(Normal); txtmove(26,18); txtattrib(11); end;
              12:begin txtcolour(Normal); txtmove(43,18); txtattrib(11); end;
            end;
          End;
          Procedure EFFACEMENT_JOUEURS;
          (* EFFACEMENT DES JOUEURS DONT LE N DEPASSE LE NOMBRE DE JOUEURS
             (EN CAS D'ENCODAGE D'UN NOMBRE DE JOUEURS INFERIEUR) *)
          Var n:byte;
          Begin
            txtback(Fond1); txtcolour(Brillant);
            for n:=(NbJoueurs + 1) to 9 do
              begin
                NomsJoueurs[n]:=''; txtmove(38,n+7); txtwrite('               ');
              end;
          End;
          Function ENCODAGE_RUBRIQUE : word;
          (* ENCODAGE D'UNE DES RUBRIQUES.
             RETOURNE LE CODE RENVOYE PAR txtvalidate2 *)
          Var Avorter:boolean;
              Erreur:integer;
              Resultat:word;
          Begin
            txtcurssize(CurseurHaut,CurseurBas);
            txtback(Fond2); txtcolour(Brillant);
            case Rubrique of
              1:begin   (* NOMBRE DE JOUEURS *)
                  str(NbJoueurs,Chaine);
                  txtmove(53,6); Resultat:=txtvalidate2(Chaine,Chaine,1,OptionLecture,[49..57]);
                  txtcursoff;
                  if Resultat and tv_Escape = 0
                     then
                       begin
                         val(Chaine,NbJoueurs,Erreur); EFFACEMENT_JOUEURS;
                       end;
                end;
            else   (* NOMS DES JOUEURS *)
              txtmove(38,Rubrique + 6); Resultat:=txtvalidate2(NomsJoueurs[Rubrique - 1],Chaine,15,OptionLecture,[0..255]);
              if Resultat and tv_Escape = 0 then NomsJoueurs[Rubrique - 1]:=Chaine;
              txtcursoff;
            end;
            ENCODAGE_RUBRIQUE:=Resultat;
          End;
          Procedure AFFICHAGE_RUBRIQUE;
          (* AFFICHAGE DU CONTENU D'UNE RUBRIQUE EN COULEUR NORMALE *)
          Begin
            txtback(Fond1); txtcolour(Brillant);
            case Rubrique of
              1:begin    (* NOMBRE DE JOUEURS *)
                  txtmove(53,6); txtnumwrite(NbJoueurs,0);
                end;
            else   (* NOMS DES JOUEURS *)
              txtmove(38,Rubrique + 6); txtwrite('               ');
              txtmove(38,Rubrique + 6); txtwrite(NomsJoueurs[Rubrique - 1]);
            end;
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Normal:=black; Fond2:=black; Brillant:=white; end;
    ModeGris:begin Fond1:=lightgrey; Normal:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=cyan; Normal:=yellow; Fond2:=black; Brillant:=white; end;
  end;
  OptionLecture:=tv_ArUp or tv_ArDn or tv_PgUp or tv_PgDn or tv_CtrlHome or tv_CtrlPgUp or tv_CtrlEnd or
                 tv_CtrlPgDn or tv_TabLe or tv_TabRi;
  xCourant:=windx; yCourant:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour; txtcursoff;
  txtwind(0,5,79,19); txtsave(Image); txtunwind;
  txtback(Fond1); txtcolour(Normal);
  txtmove(20,5);  txtwrite('  Noms des joueurs ͻ ');
  txtmove(20,6);  txtwrite('   Nombre de joueurs (1  9) : <1>    ');
  txtmove(20,7);  txtwrite('                                      ');
  txtmove(20,8);  txtwrite('     Joueur 1 : <               >     ');
  txtmove(20,9);  txtwrite('     Joueur 2 : <               >     ');
  txtmove(20,10); txtwrite('     Joueur 3 : <               >     ');
  txtmove(20,11); txtwrite('     Joueur 4 : <               >     ');
  txtmove(20,12); txtwrite('     Joueur 5 : <               >     ');
  txtmove(20,13); txtwrite('     Joueur 6 : <               >     ');
  txtmove(20,14); txtwrite('     Joueur 7 : <               >     ');
  txtmove(20,15); txtwrite('     Joueur 8 : <               >     ');
  txtmove(20,16); txtwrite('     Joueur 9 : <               >     ');
  txtmove(20,17); txtwrite('                                      ');
  txtmove(20,18); txtwrite('    <     Ok    >    <  Quitter  >    ');
  txtmove(20,19); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(31,5); txtattrib(18);
  NbJoueurs:=1; Rubrique:=1; RUBRIQUE_ALLUMEE;
  txtflush; mouseeventparams.me_modified:=false;
  Fin:=false; if Souris then Void:=txtmousecurson;
  txtsimulatekey(13,28);
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   15,72:begin   (* TAB GAUCHE / FLECHE HAUT : RUBRIQUE PRECEDENTE *)
                           if Souris then Void:=txtmousecursoff;
                           RUBRIQUE_ETEINTE;
                           case Rubrique of
                             1:Rubrique:=12;
                             12:Rubrique:=11;
                           else
                             dec(Rubrique); txtsimulatekey(13,18);
                           end;
                           RUBRIQUE_ALLUMEE;
                           if Souris then Void:=txtmousecurson;
                         end;
                   73,119,132:begin   (* PAGE HAUT / ^HOME / ^PAGE HAUT : RUBRIQUE "NOMBRE JOUEURS" *)
                                if Souris then Void:=txtmousecursoff;
                                RUBRIQUE_ETEINTE; Rubrique:=1; RUBRIQUE_ALLUMEE; txtsimulatekey(13,18);
                                if Souris then Void:=txtmousecurson;
                              end;
                   80:begin   (* FLECHE BAS : RUBRIQUE SUIVANTE *)
                        if Souris then Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE;
                        case Rubrique of
                          10,11:inc(Rubrique);
                          12:begin Rubrique:=1; txtsimulatekey(13,18); end;
                        else
                          inc(Rubrique); txtsimulatekey(13,18);
                        end;
                        RUBRIQUE_ALLUMEE;
                        if Souris then Void:=txtmousecurson;
                      end;
                   81,117,118:begin   (* PAGE BAS / ^END / ^PAGE BAS : RUBRIQUE "OK" *)
                                if Souris then Void:=txtmousecursoff;
                                RUBRIQUE_ETEINTE; Rubrique:=11; RUBRIQUE_ALLUMEE;
                                if Souris then Void:=txtmousecurson;
                              end;
                 end;
               end;
             9:begin   (* TAB DROITE : RUBRIQUE SUIVANTE *)
                 if Souris then Void:=txtmousecursoff;
                 RUBRIQUE_ETEINTE;
                 case Rubrique of
                   10,11:inc(Rubrique);
                   12:begin Rubrique:=1; txtsimulatekey(13,18); end;
                 else
                   inc(Rubrique); txtsimulatekey(13,18);
                 end;
                 RUBRIQUE_ALLUMEE;
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : CHOIX D'UNE RUBRIQUE *)
                  if Souris then Void:=txtmousecursoff;
                  RUBRIQUE_ETEINTE;
                  case Rubrique of
                    1:begin
                        Res:=ENCODAGE_RUBRIQUE; AFFICHAGE_RUBRIQUE;
                        if (Res = tv_Enter) or (Res = tv_ArDn) or (Res = tv_TabRi)
                           then
                             begin
                               inc(Rubrique); txtsimulatekey(13,18);
                             end
                           else
                             if Res = tv_ArUp
                                then
                                  Rubrique:=12
                                else
                                  if (Res = tv_PgDn) or (Res = tv_CtrlPgDn) or (Res = tv_CtrlEnd)
                                     then
                                       Rubrique:=11
                                     else
                                       if (Res = tv_PgUp) or (Res = tv_CtrlPgUp) or (Res = tv_CtrlHome)
                                          then
                                            begin
                                              Rubrique:=1; txtsimulatekey(13,18);
                                            end;
                      end;
                    2..10:if Rubrique <= (NbJoueurs + 1)
                             then
                               begin
                                 Res:=ENCODAGE_RUBRIQUE; AFFICHAGE_RUBRIQUE;
                                 if (Res = tv_Enter) or (Res = tv_ArDn) or (Res = tv_TabRi)
                                    then
                                      begin
                                        inc(Rubrique); if Rubrique <= 10 then txtsimulatekey(13,18);
                                      end
                                    else
                                      if Res = tv_ArUp
                                         then
                                           begin
                                             dec(Rubrique); txtsimulatekey(13,18);
                                           end
                                         else
                                           if (Res = tv_PgDn) or (Res = tv_CtrlPgDn) or (Res = tv_CtrlEnd)
                                              then
                                                Rubrique:=11
                                              else
                                                if (Res = tv_PgUp) or (Res = tv_CtrlPgUp) or (Res = tv_CtrlHome)
                                                   then
                                                     begin
                                                       Rubrique:=1; txtsimulatekey(13,18);
                                                     end;
                               end;
                    11:begin   (* "OK" *)
                         Fin:=true; for Rubrique:=1 to NbJoueurs do if NomsJoueurs[Rubrique] = '' then Fin:=false;
                         Rubrique:=11;
                         if Fin then ENCODAGE_JOUEURS:=NbJoueurs;
                       end;
                    12:begin   (* "QUITTER" *)
                         Fin:=true; ENCODAGE_JOUEURS:=0;
                       end;
                  end;
                  RUBRIQUE_ALLUMEE;
                  if Souris then Void:=txtmousecurson;
                end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             case me_y of
               6:if me_x = 53
                    then   (* NOMBRE DE JOUEURS *)
                      begin
                        Void:=txtmousecursoff;
                        RUBRIQUE_ETEINTE; Rubrique:=1;
                        Res:=ENCODAGE_RUBRIQUE; AFFICHAGE_RUBRIQUE;
                        if (Res = tv_Enter) or (Res = tv_ArDn) or (Res = tv_TabRi)
                           then
                             begin
                               inc(Rubrique); txtsimulatekey(13,18);
                             end
                           else
                             if Res = tv_ArUp
                                then
                                  Rubrique:=12
                                else
                                  if (Res = tv_PgDn) or (Res = tv_CtrlPgDn) or (Res = tv_CtrlEnd)
                                     then
                                       Rubrique:=11
                                     else
                                       if (Res = tv_PgUp) or (Res = tv_CtrlPgUp) or (Res = tv_CtrlHome)
                                          then
                                            begin
                                              Rubrique:=1; txtsimulatekey(13,18);
                                            end;
                        RUBRIQUE_ALLUMEE;
                        Void:=txtmousecurson;
                      end;
               8..16:if me_x in [38..52]
                        then   (* NOMS DES JOUEURS *)
                          if me_y <= (NbJoueurs + 7)
                             then
                               begin
                                 Void:=txtmousecursoff;
                                 RUBRIQUE_ETEINTE; Rubrique:=me_y - 6;
                                 Res:=ENCODAGE_RUBRIQUE; AFFICHAGE_RUBRIQUE;
                                 if (Res = tv_Enter) or (Res = tv_ArDn) or (Res = tv_TabRi)
                                    then
                                      begin
                                        inc(Rubrique); if Rubrique <= 10 then txtsimulatekey(13,18);
                                      end
                                    else
                                      if Res = tv_ArUp
                                         then
                                           begin
                                             dec(Rubrique); txtsimulatekey(13,18);
                                           end
                                         else
                                           if (Res = tv_PgDn) or (Res = tv_CtrlPgDn) or (Res = tv_CtrlEnd)
                                              then
                                                Rubrique:=11
                                              else
                                                if (Res = tv_PgUp) or (Res = tv_CtrlPgUp) or (Res = tv_CtrlHome)
                                                   then
                                                     begin
                                                       Rubrique:=1; txtsimulatekey(13,18);
                                                     end;
                                 RUBRIQUE_ALLUMEE;
                                 Void:=txtmousecurson;
                               end;
               18:case me_x of
                    26..36:begin   (* BOUTON "OK" *)
                             Void:=txtmousecursoff;
                             RUBRIQUE_ETEINTE;
                             Fin:=true; for Rubrique:=1 to NbJoueurs do if NomsJoueurs[Rubrique] = '' then Fin:=false;
                             if Fin then ENCODAGE_JOUEURS:=NbJoueurs;
                             Rubrique:=11; RUBRIQUE_ALLUMEE;
                             Void:=txtmousecurson;
                           end;
                    43..53:begin   (* BOUTON "QUITTER" *)
                             if Souris then Void:=txtmousecursoff;
                             RUBRIQUE_ETEINTE; Rubrique:=12; RUBRIQUE_ALLUMEE;
                             if Souris then Void:=txtmousecurson;
                             Fin:=true; ENCODAGE_JOUEURS:=0;
                           end;
                  end;
             end;
             me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  txtwind(0,5,79,19); txtload(Image); txtunwind;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(xCourant,yCourant);
End;


Function FIN_MARQUE : boolean;
(* APRES LA MARQUE DANS LA FEUILLE DE POINTS, DEMANDE SI CORRIGER LA MARQUE OU
   SI PASSAGE AU JOUEUR SUIVANT OU SI FIN DE PARTIE OU SI QUITTER LE JEU.
   RETOURNE true SI PASSAGE AU JOUEUR SUIVANT. *)
(* CREEE VERSION 2.20 *)
Var xCourant,yCourant,FondCourant,CouleurCourante,Haut,Bas:word;
    Fond1,Normal,Fond2,Brillant:word;
    Image:videosave;
    Bouton:byte;
    Entree:char;
    Fin:boolean;
          Procedure BOUTON_ALLUME;
          (* MISE EN SURBRILLANCE D'UN BOUTON *)
          Begin
            txtback(Fond2); txtcolour(Brillant);
            txtmove(28,Bouton + 8); txtattrib(18);
          End;
          Procedure BOUTON_ETEINT;
          (* FIN DE LA MISE EN SURBRILLANCE D'UN BOUTON *)
          Begin
            txtback(Fond1); txtcolour(Normal);
            txtmove(28,Bouton + 8); txtattrib(18);
          End;
Begin
  case ModeEcran of
    ModeMono,ModeGris:begin Fond1:=lightgrey; Normal:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=cyan; Normal:=yellow; Fond2:=black; Brillant:=white; end;
  end;
  xCourant:=windx; yCourant:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour; txtgetcurssize(Haut,Bas);
  txtcursoff;
  txtwind(24,4,49,20); txtsave(Image); txtback(black); txtcolour(lightgrey); txtclear; txtunwind;
  txtback(Fond1); txtcolour(Normal);
  txtmove(24,8);  txtwrite('  Fin de la marque ͻ ');
  txtmove(24,9);  txtwrite('  <  Joueur suivant  >  ');
  txtmove(24,10); txtwrite('  <  Corriger points >  ');
  txtmove(24,11); txtwrite('  <  Rgles du jeu   >  ');
  txtmove(24,12); txtwrite('  <  Points actuels  >  ');
  txtmove(24,13); txtwrite('  <   Nouveau jeu    >  ');
  txtmove(24,14); txtwrite('  <  Quitter le jeu  >  ');
  txtmove(24,15); txtwrite(' ͼ ');
  txtcolour(Brillant); txtmove(28,8); txtattrib(18);
  txtflush; mouseeventparams.me_modified:=false;
  Bouton:=1; BOUTON_ALLUME; Fin:=false;
  if Souris then Void:=txtmousecurson;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   59:begin   (* F1 : REGLES DU JEU *)
                        if Souris then Void:=txtmousecursoff;
                        REGLES_DU_JEU;
                        if Souris then Void:=txtmousecurson;
                      end;
                   60:begin   (* F2 : SITUATION ACTUELLE *)
                        if Souris then Void:=txtmousecursoff;
                        SITUATION_ACTUELLE(Joueur);
                        if Souris then Void:=txtmousecurson;
                      end;
                   67:begin   (* F9 : NOUVELLE PARTIE *)
                        FinPartie:=CONFIRMATION(1); if FinPartie then begin Fin:=true; FIN_MARQUE:=true; end;
                      end;
                   68:begin   (* F10 : QUITTER LE JEU *)
                        FinJeu:=CONFIRMATION(2); if FinJeu then begin Fin:=true; FIN_MARQUE:=true; end;
                      end;
                   15,72:begin   (* TAB GAUCHE / FLECHE GAUCHE : BOUTON PRECEDENT *)
                           if Souris then Void:=txtmousecursoff;
                           BOUTON_ETEINT; if Bouton = 1 then Bouton:=6 else dec(Bouton); BOUTON_ALLUME;
                           if Souris then Void:=txtmousecurson;
                         end;
                   80:begin   (* FLECHE DROITE : BOUTON SUIVANT *)
                        if Souris then Void:=txtmousecursoff;
                        BOUTON_ETEINT; if Bouton = 6 then Bouton:=1 else inc(Bouton); BOUTON_ALLUME;
                        if Souris then Void:=txtmousecurson;
                      end;
                 end;
               end;
             9:begin   (* TAB DROITE : BOUTON SUIVANT *)
                 if Souris then Void:=txtmousecursoff;
                 BOUTON_ETEINT; if Bouton = 6 then Bouton:=1 else inc(Bouton); BOUTON_ALLUME;
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : SELECTION DU BOUTON COURANT *)
                  if Souris then Void:=txtmousecursoff;
                  BOUTON_ETEINT;
                  case Bouton of
                    1:begin Fin:=true; FIN_MARQUE:=true; end;
                    2:begin Fin:=true; FIN_MARQUE:=false; end;
                    3:REGLES_DU_JEU;
                    4:SITUATION_ACTUELLE(Joueur);
                    5:begin FinPartie:=CONFIRMATION(1); if FinPartie then begin Fin:=true; FIN_MARQUE:=true; end; end;
                    6:begin FinJeu:=CONFIRMATION(2); if FinJeu then begin Fin:=true; FIN_MARQUE:=true; end; end;
                  end;
                  BOUTON_ALLUME;
                  if Souris then Void:=txtmousecurson;
                end;
             255:begin   (* ALT-255 : MESSAGE PERSONNEL *)
                   if Souris then Void:=txtmousecursoff;
                   MESSAGE_PERSONNEL;
                   if Souris then Void:=txtmousecurson;
                 end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if me_x in [28..45]
                then
                  case me_y of
                    9:begin   (* BOUTON "JOUEUR SUIVANT" *)
                        Void:=txtmousecursoff;
                        BOUTON_ETEINT; Bouton:=1; BOUTON_ALLUME;
                        Void:=txtmousecurson;
                        Fin:=true; FIN_MARQUE:=true;
                      end;
                    10:begin   (* BOUTON "CORRIGER LA MARQUE" *)
                         Void:=txtmousecursoff;
                         BOUTON_ETEINT; Bouton:=2; BOUTON_ALLUME;
                         Void:=txtmousecurson;
                         Fin:=true; FIN_MARQUE:=false;
                       end;
                    11:begin   (* BOUTON "REGLES DU JEU " *)
                         Void:=txtmousecursoff;
                         BOUTON_ETEINT; REGLES_DU_JEU; Bouton:=3; BOUTON_ALLUME;
                         Void:=txtmousecurson;
                       end;
                    12:begin   (* BOUTON "SITUATION ACTUELLE" *)
                         Void:=txtmousecursoff;
                         BOUTON_ETEINT; SITUATION_ACTUELLE(Joueur); Bouton:=4; BOUTON_ALLUME;
                         Void:=txtmousecurson;
                       end;
                    13:begin   (* BOUTON "NOUVELLE PARTIE" *)
                         Void:=txtmousecursoff;
                         BOUTON_ETEINT; Bouton:=5; BOUTON_ALLUME;
                         FinPartie:=CONFIRMATION(1); if FinPartie then begin Fin:=true; FIN_MARQUE:=true; end;
                         Void:=txtmousecurson;
                       end;
                    14:begin   (* BOUTON "QUITTER LE JEU" *)
                         Void:=txtmousecursoff;
                         BOUTON_ETEINT; Bouton:=6; BOUTON_ALLUME;
                         FinJeu:=CONFIRMATION(2); if FinJeu then begin Fin:=true; FIN_MARQUE:=true; end;
                         Void:=txtmousecurson;
                       end;
                  end;
             me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  txtwind(24,4,49,20); txtload(Image); txtunwind;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(xCourant,yCourant); txtcurssize(Haut,Bas);
End;


Function CONFIRMATION (n:byte) : boolean;
(* BOITE DE DIALOGUE DE CONFIRMATION DE COMMANDE.
   n : 1 = CONFIRMATION FIN DU JEU ET NOUVELLE PARTIE;
       2 = CONFIRMATION QUITTER LE JEU;
   RETOURNE true SI REPONSE "OUI". *)
Var x,y,Fond,Couleur,Haut,Bas:word;
    Fond1,Normal1,Fond2,Normal2,Bouton:byte;
    Image:videosave;
    Entree:char;
    Fin:boolean;
          Procedure BOUTON_ALLUME;
          (* MISE EN SURBRILLANCE DU BOUTON Bouton *)
          Begin
            txtback(Fond2); txtcolour(Normal2);
            if Bouton = 1 then txtmove(22,12) else txtmove(44,12); txtattrib(13);
          End;
          Procedure BOUTON_ETEINT;
          (* FIN DE LA MISE EN SURBRILLANCE DU BOUTON Bouton *)
          Begin
            txtback(Fond1); txtcolour(Normal1);
            if Bouton = 1 then txtmove(22,12) else txtmove(44,12); txtattrib(13);
          End;
Begin
  x:=windx; y:=windy; Fond:=textbackgr; Couleur:=textcolour; txtgetcurssize(Haut,Bas); txtcursoff;
  txtwind(0,10,79,13); txtsave(Image); txtunwind;
  case ModeEcran of
    ModeMono,ModeGris:begin Fond1:=lightgrey; Normal1:=black; Fond2:=black; Normal2:=white; end;
    ModeCouleur:begin Fond1:=magenta; Normal1:=yellow; Fond2:=black; Normal2:=white; end;
  end;
  txtback(Fond1); txtcolour(Normal1);
  txtmove(3,10); txtwrite('  Confirmation ͻ ');
  txtmove(3,11);
  case n of
    1:txtwrite('  Voulez-vous cesser le jeu en cours pour faire une nouvelle partie ?  ');
    2:txtwrite('        Voulez-vous vraiment quitter ce magnifique programme ?         ');
  end;
  txtmove(3,12); txtwrite('                 <    (O)ui    >       <    (N)on    >                 ');
  txtmove(3,13); txtwrite(' ͼ ');
  txtcolour(Normal2); txtmove(32,10); txtattrib(14);
  txtflush; mouseeventparams.me_modified:=false;
  Bouton:=1; BOUTON_ALLUME; Fin:=false;
  if Souris then Void:=txtmousecurson;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   15,75,77:begin   (* TAB GAUCHE / FLECHE GAUCHE / FLECHE DROITE : AUTRE BOUTON *)
                              if Souris then Void:=txtmousecursoff;
                              BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ALLUME;
                              if Souris then Void:=txtmousecurson;
                            end;
                 end;
               end;
             9:begin   (* TAB DROITE : AUTRE BOUTON *)
                 if Souris then Void:=txtmousecursoff;
                 BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ALLUME;
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER : SELECTION D'UN BOUTON *)
                  Fin:=true; CONFIRMATION:=(Bouton = 1);
                end;
             78,110:begin   (* 'N','n' : BOUTON "NON" *)
                      if Souris then Void:=txtmousecursoff;
                      BOUTON_ETEINT; Bouton:=2; BOUTON_ALLUME;
                      if Souris then Void:=txtmousecurson;
                      Fin:=true; CONFIRMATION:=false;
                    end;
             79,111:begin   (* 'O','o' : BOUTON "OUI" *)
                      if Souris then Void:=txtmousecursoff;
                      BOUTON_ETEINT; Bouton:=1; BOUTON_ALLUME;
                      if Souris then Void:=txtmousecurson;
                      Fin:=true; CONFIRMATION:=true;
                    end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if me_y = 12
                then
                  case me_x of
                    22..33:begin   (* BOUTON "OUI" *)
                             Void:=txtmousecursoff;
                             BOUTON_ETEINT; Bouton:=1; BOUTON_ALLUME;
                             Void:=txtmousecurson;
                             Fin:=true; CONFIRMATION:=true;
                           end;
                    44..55:begin   (* BOUTON "NON" *)
                             Void:=txtmousecursoff;
                             BOUTON_ETEINT; Bouton:=2; BOUTON_ALLUME;
                             Void:=txtmousecurson;
                             Fin:=true; CONFIRMATION:=false;
                           end;
                  end;
             me_modified:=false;
           end;
  until Fin;
  if Souris then Void:=txtmousecursoff;
  txtwind(0,10,79,13); txtload(Image); txtunwind;
  txtback(Fond); txtcolour(Couleur); txtmove(x,y); txtcurssize(Haut,Bas);
End;


Procedure SITUATION_ACTUELLE (JoueurCourant:byte);
(* AFFICHAGE DES POINTS ACTUELS DE TOUS LES JOUEURS (PRIMES COMPRISES).
   JoueurCourant EST LE JOUEUR EN TRAIN DE JOUER (POUR CALCUL DU NOMBRE DE COUPS JOUES) *)
(* MODIFIEE VERSION 2.20 *)
Var Image:videosave;
    xCourant,yCourant,FondCourant,CouleurCourante,Haut,Bas:word;
    Fond1,Normal1,Fond2,Normal2,FondCadre,ClrCadre,ClrNoms,ClrCoups,ClrPoints:byte;
    TotalColonne,Total:word;
    Joueur,y,Ligne,Colonne:byte;
    Entree:char;
    Fin:boolean;
Begin
  case ModeEcran of
    ModeMono,ModeGris:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Normal2:=white;
               FondCadre:=black; ClrCadre:=lightgrey; ClrNoms:=white; ClrCoups:=white; ClrPoints:=white;
             end;
    ModeCouleur:begin
                  Fond1:=cyan; Normal1:=yellow; Fond2:=black; Normal2:=white;
                  FondCadre:=red; ClrCadre:=yellow; ClrNoms:=yellow; ClrCoups:=lightmagenta; ClrPoints:=lightcyan;
                end;
  end;
  txtgetcurssize(Haut,Bas); txtcursoff;
  xCourant:=windx; yCourant:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtwind(0,3,79,20); txtsave(Image); txtunwind;
  txtback(Fond1); txtcolour(Normal1);
  txtmove(16,3); txtwrite('  Situation actuelle (primes comprises) ͻ ');
  for y:=4 to 18 do
    begin
      txtmove(16,y); txtwrite('                                              ');
    end;
  txtmove(16,19); txtwrite('                <    (O)k    >                ');
  txtmove(16,20); txtwrite(' ͼ ');
  txtcolour(Normal2); txtmove(21,3); txtattrib(39);
  txtback(FondCadre); txtcolour(ClrCadre);
  txtmove(19,5); txtwrite('ͻ');
  txtmove(19,6); txtwrite('       Nom        Coups jous  Points ');
  txtmove(19,7); txtwrite('Ķ');
  for y:=8 to 16 do
    begin
      txtmove(19,y); txtwrite('                                      ');
    end;
  txtmove(19,17); txtwrite('ͼ');
  txtback(Fond2); txtcolour(Normal2); txtmove(34,19); txtattrib(12);
  txtback(FondCadre);
  y:=8;
  for Joueur:=1 to NbJoueurs do
    begin
      Total:=0;
      (* SECTION SUPERIEURE *)
      for Colonne:=1 to 3 do
        begin
          TotalColonne:=0;
          for Ligne:=fp_As to fp_Six do
            if FeuillePoints[Joueur,Ligne,Colonne] <> 65535 then inc(TotalColonne,FeuillePoints[Joueur,Ligne,Colonne]);
          if TotalColonne >= 63 then inc(TotalColonne,35);   (* AJOUT EVENTUEL DE LA PRIME *)
          inc(Total,TotalColonne * Colonne);
        end;
      (* SECTION INFERIEURE *)
      for Colonne:=1 to 3 do
        begin
          TotalColonne:=0;
          for Ligne:=fp_Brelan to fp_Chance do
            if FeuillePoints[Joueur,Ligne,Colonne] <> 65535 then inc(TotalColonne,FeuillePoints[Joueur,Ligne,Colonne]);
          inc(Total,TotalColonne * Colonne);
        end;
      (* PRIMES YAHTZEE *)
      inc(Total,TableauPrimes[Joueur]);
      (* AFFICHAGE *)
      txtcolour(ClrNoms); txtmove(21,y); txtwrite(NomsJoueurs[Joueur]);
      txtcolour(ClrCoups); txtmove(44,y);
      if Joueur < JoueurCourant
         then
           txtnumwrite(Coup,2)
         else
           if Joueur > JoueurCourant
              then
                txtnumwrite(Coup-1,2)
              else
                if PointsMarques then txtnumwrite(Coup,2) else txtnumwrite(Coup-1,2);
      txtcolour(ClrPoints); txtmove(54,y); txtnumwrite(Total,4);
      inc(y);
    end;
  txtflush; if Souris then mouseeventparams.me_modified:=false;
  if Souris then Void:=txtmousecurson;
  Fin:=false;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:txtinput(Entree);
             13,79,111:Fin:=true;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_x in [34..45]) and (me_y = 19) then Fin:=true;
             me_modified:=false;
           end;
  until (Fin);
  if Souris then Void:=txtmousecursoff;
  txtwind(0,3,79,20); txtload(Image); txtunwind;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(xCourant,yCourant); txtcurssize(Haut,Bas);
End;


Procedure RESUME_FINAL;
(* AFFICHAGE DES POINTS DE TOUS LES JOUEURS : SANS LES PRIMES, PRIMES, TOTAL *)
(* MODIFIEE VERSION 2.20 *)
Var xCourant,yCourant,FondCourant,CouleurCourante,Haut,Bas:word;
    Fond1,Normal1,Fond2,Normal2,FondCadre,ClrCadre,ClrNoms,Clr1,Clr2,Clr3:byte;
    Joueur,y,Ligne,Colonne:byte;
    Entree:char;
    Fin:boolean;
Begin
  case ModeEcran of
    ModeMono,ModeGris:begin
               Fond1:=lightgrey; Normal1:=black; Fond2:=black; Normal2:=white;
               FondCadre:=black; ClrCadre:=lightgrey; ClrNoms:=white; Clr1:=white; Clr2:=white; Clr3:=white;
             end;
    ModeCouleur:begin
                  Fond1:=cyan; Normal1:=yellow; Fond2:=black; Normal2:=white;
                  FondCadre:=red; ClrCadre:=yellow; ClrNoms:=white; Clr1:=lightgreen; Clr2:=yellow; Clr3:=lightcyan;
                end;
  end;
  txtgetcurssize(Haut,Bas); txtcursoff;
  xCourant:=windx; yCourant:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtback(Fond1); txtcolour(Normal1);
  txtmove(14,3); txtwrite('  Rsultat final ͻ ');
  for y:=4 to 18 do
    begin
      txtmove(14,y); txtwrite('                                                  ');
    end;
  txtmove(14,19); txtwrite('                  <    (O)k    >                  ');
  txtmove(14,20); txtwrite(' ͼ ');
  txtcolour(Normal2); txtmove(32,3); txtattrib(16);
  txtback(FondCadre); txtcolour(ClrCadre);
  txtmove(17,5); txtwrite('ͻ');
  txtmove(17,6); txtwrite('       Nom       Rsultat Primes  Total  ');
  txtmove(17,7); txtwrite('Ķ');
  for y:=8 to 16 do
    begin
      txtmove(17,y); txtwrite('                                         ');
    end;
  txtmove(17,17); txtwrite('ͼ');
  txtback(Fond2); txtcolour(Normal2); txtmove(34,19); txtattrib(12);
  txtback(FondCadre);
  y:=8;
  for Joueur:=1 to NbJoueurs do
    begin
      txtcolour(ClrNoms); txtmove(19,y); txtwrite(NomsJoueurs[Joueur]);
      txtcolour(Clr1); txtmove(38,y); txtnumwrite(FeuillePoints[Joueur,17,1],4);
      txtcolour(Clr2); txtmove(47,y); txtnumwrite(TableauPrimes[Joueur],4);
      txtcolour(Clr3); txtmove(56,y); txtnumwrite(FeuillePoints[Joueur,17,1] + TableauPrimes[Joueur],4);
      inc(y);
    end;
  txtflush; if Souris then mouseeventparams.me_modified:=false;
  if Souris then Void:=txtmousecurson;
  Fin:=false;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:txtinput(Entree);
             13,79,111:Fin:=true;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_x in [34..45]) and (me_y = 19) then Fin:=true;
             me_modified:=false;
           end;
  until (Fin);
  if Souris then Void:=txtmousecursoff;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(xCourant,yCourant); txtcurssize(Haut,Bas);
End;


Procedure BOUTON_OK;
(* BOUTON "OK" SIMPLE A LA PLACE DES MENUS TRAITEMENT DES OU ECRITURE FEUILLE DE POINTS *)
(* CREEE VERSION 2.20 *)
Var Image:videosave;
    x,y,FondCourant,CouleurCourante,Fond1,Normal,Fond2,Brillant,Haut,Bas:word;
    Entree:char;
    Ok:boolean;
Begin
  case ModeEcran of
    ModeMono,ModeGris:begin Fond1:=lightgrey; Normal:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=cyan; Normal:=yellow; Fond2:=black; Brillant:=white; end;
  end;
  x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour; txtgetcurssize(Haut,Bas); txtcursoff;
  txtback(black); txtcolour(lightgrey); txtwind(24,4,49,20); txtsave(Image); txtclear; txtunwind;
  txtback(Fond1); txtcolour(Normal);
  txtmove(24,11); txtwrite(' ͻ ');
  txtmove(24,12); txtwrite('    <     (O)k     >    ');
  txtmove(24,13); txtwrite(' ͼ ');
  txtback(Fond2); txtcolour(Brillant); txtmove(30,12); txtattrib(14);
  txtflush; mouseeventparams.me_modified:=false;
  Ok:=false; if Souris then Void:=txtmousecurson;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:txtinput(Entree);
             13,79,111:Ok:=true;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_y = 12) and (me_x in [30..43]) then Ok:=true;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtwind(24,4,49,20); txtload(Image); txtunwind;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y); txtcurssize(Haut,Bas);
End;


Function MESSAGE_ERREUR (Erreur:byte) : boolean;
(* AFFICHAGE MESSAGE D'ERREUR DISQUE ET RECOMMENCER/ABANDONNER.
   RETOURNE false SI ABANDONNER. *)
(* CREEE VERSION 2.20 *)
Var Image:videosave;
    xCourant,yCourant,FondCourant,CouleurCourante:word;
    Fond1,Fond2,Clr1,Clr2:byte;
    Entree:char;
    Bouton:byte;
    Ok:boolean;
          Procedure BOUTON_ALLUME;
          (* SURBRILLANCE D'UN BOUTON *)
          Begin
            txtback(Fond2); txtcolour(Clr2);
            if Bouton = 1 then txtmove(21,13) else txtmove(43,13); txtattrib(17);
          End;
          Procedure BOUTON_ETEINT;
          (* FIN DE LA SURBRILLANCE D'UN BOUTON *)
          Begin
            txtback(Fond1); txtcolour(Clr1);
            if Bouton = 1 then txtmove(21,13) else txtmove(43,13); txtattrib(17);
          End;
Begin
  case ModeEcran of
    ModeMono:begin Fond1:=lightgrey; Fond2:=black; Clr1:=black; Clr2:=white; end;
    ModeGris:begin Fond1:=lightgrey; Fond2:=black; Clr1:=white; Clr2:=white; end;
    ModeCouleur:begin Fond1:=magenta; Fond2:=black; Clr1:=yellow; Clr2:=white; end;
  end;
  xCourant:=windx; yCourant:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtwind(0,11,79,14); txtsave(Image); txtunwind;
  txtback(Fond1); txtcolour(Clr1);
  txtmove(8,11);txtwrite('  Erreur disque ͻ ');
  txtmove(8,12);txtwrite('                                                             ');
  txtmove(8,13);txtwrite('                                                             ');
  txtmove(8,14);txtwrite(' ͼ ');
  txtmove(11,12);
  case Erreur of
    0:txtwrite('   ERREUR : Impossible de lire le rpertoire courant');
    1:txtwrite('  ERREUR : Impossible de crer le fichier ' + NomFichier);
    2:txtwrite('  ERREUR : Impossible d''ouvrir le fichier ' + NomFichier);
    3:txtwrite('   ERREUR : Impossible de lire le fichier ' + NomFichier);
    4:txtwrite('ERREUR : Impossible d''crire dans le fichier ' + NomFichier);
    5:txtwrite('  ERREUR : Impossible de fermer le fichier ' + NomFichier);
  end;
  txtmove(20,13); txtwrite('<  (R)ecommencer  >   <   (A)bandonner  >');
  txtcolour(Clr2); txtmove(32,11); txtattrib(15);
  BOUTON_ALLUME;
  txtflush; mouseeventparams.me_modified:=false; Ok:=false;
  if Souris then Void:=txtmousecurson;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:begin
                 txtinput(Entree);
                 case ord(Entree) of
                   15,75,77:begin   (* FLECHE GAUCHE / FLECHE DROITE *)
                              if Souris then Void:=txtmousecursoff;
                               BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ALLUME;
                               if Souris then Void:=txtmousecurson;
                            end;
                 end;
               end;
             9:begin   (* TAB DROITE *)
                 if Souris then Void:=txtmousecursoff;
                 BOUTON_ETEINT; if Bouton = 1 then Bouton:=2 else Bouton:=1; BOUTON_ALLUME;
                 if Souris then Void:=txtmousecurson;
               end;
             13:begin   (* ENTER *)
                  MESSAGE_ERREUR:=(Bouton = 1); Ok:=true;
                end;
             65,97:begin   (* 'A','a'  *)
                     if Souris then Void:=txtmousecursoff;
                     BOUTON_ETEINT; Bouton:=2; BOUTON_ALLUME;
                     if Souris then Void:=txtmousecurson;
                     MESSAGE_ERREUR:=false; Ok:=true;
                   end;
             82,114:begin   (* 'R','r' *)
                      if Souris then Void:=txtmousecursoff;
                      BOUTON_ETEINT; Bouton:=1; BOUTON_ALLUME;
                      if Souris then Void:=txtmousecurson;
                      MESSAGE_ERREUR:=true; Ok:=true;
                    end;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if me_y = 13
                then
                  case me_x of
                    21..37:begin   (* BOUTON "RECOMMENCER" *)
                             Void:=txtmousecursoff;
                             BOUTON_ETEINT; Bouton:=1; BOUTON_ALLUME;
                             Void:=txtmousecurson;
                             MESSAGE_ERREUR:=true;
                             Ok:=true;
                           end;
                    43..59:begin   (* BOUTON "ABANDONNER" *)
                             Void:=txtmousecursoff;
                             BOUTON_ETEINT; Bouton:=2; BOUTON_ALLUME;
                             Void:=txtmousecurson;
                             MESSAGE_ERREUR:=false;
                             Ok:=true;
                           end;
                  end;
             mouseeventparams.me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtwind(0,11,79,14); txtload(Image); txtunwind;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(xCourant,yCourant);
End;


Procedure INSERER_DISQUETTE;
(* BOITE DE DIALOGUE INSERTION DISQUETTE AVEC BOUTON "OK" *)
(* CREEE VERSION 2.20 *)
Var Image:videosave;
    x,y,FondCourant,CouleurCourante,Fond1,Normal,Fond2,Brillant,Haut,Bas:word;
    Entree:char;
    Ok:boolean;
Begin
  case ModeEcran of
    ModeMono,ModeGris:begin Fond1:=lightgrey; Normal:=black; Fond2:=black; Brillant:=white; end;
    ModeCouleur:begin Fond1:=cyan; Normal:=yellow; Fond2:=black; Brillant:=white; end;
  end;
  x:=windx; y:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour; txtgetcurssize(Haut,Bas); txtcursoff;
  txtwind(0,10,79,13); txtsave(Image); txtunwind;
  txtback(Fond1); txtcolour(Normal);
  txtmove(7,10); txtwrite(' ͻ ');
  txtmove(7,11); txtwrite('  Insrez la disquette contenant YAHTZEE1.RES et YAHTZEE2.RES  ');
  txtmove(7,12); txtwrite('                        <     (O)k     >                       ');
  txtmove(7,13); txtwrite(' ͼ ');
  txtback(Fond2); txtcolour(Brillant); txtmove(33,12); txtattrib(14);
  txtflush; mouseeventparams.me_modified:=false;
  Ok:=false; if Souris then Void:=txtmousecurson;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:txtinput(Entree);
             13,79,111:Ok:=true;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_y = 12) and (me_x in [33..46]) then Ok:=true;
             me_modified:=false;
           end;
  until Ok;
  if Souris then Void:=txtmousecursoff;
  txtwind(0,10,79,13); txtload(Image); txtunwind;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(x,y); txtcurssize(Haut,Bas);
End;


Procedure AFFICHAGE_CLASSEMENTS;
(* AFFICHAGE DES 2 CLASSEMENTS (SANS ET AVEC PRIMES) *)
(* CREEE VERSION 2.20 *)
Var xCourant,yCourant,FondCourant,CouleurCourante,Haut,Bas:word;
    Fond1,Normal1,Fond2,Normal2,FondCadre,ClrCadre,Clr1,Clr2,Clr3,Clr4:byte;
    y:byte;
    Entree:char;
    Fin:boolean;
Begin
  case ModeEcran of
    ModeMono,ModeGris:begin
                        Fond1:=lightgrey; Normal1:=black; Fond2:=black; Normal2:=white;
                        FondCadre:=black; ClrCadre:=lightgrey; Clr1:=lightgrey; Clr2:=white; Clr3:=white; Clr4:=lightgrey;
                      end;
    ModeCouleur:begin
                  Fond1:=cyan; Normal1:=yellow; Fond2:=black; Normal2:=white;
                  FondCadre:=red; ClrCadre:=yellow; Clr1:=lightgreen; Clr2:=white; Clr3:=lightcyan; Clr4:=cyan;
                end;
  end;
  txtgetcurssize(Haut,Bas); txtcursoff;
  xCourant:=windx; yCourant:=windy; FondCourant:=textbackgr; CouleurCourante:=textcolour;
  txtback(black); txtcolour(lightgrey); txtclear;
  txtback(FondCadre); txtcolour(ClrCadre);
  txtmove(1,0); txtwrite(' Classement SANS primes Yahtzee ͻ   Classement AVEC primes Yahtzee ͻ');
  txtmove(1,1); txtwrite('   Date         Nom      S.P.A.P.     Date         Nom      S.P.A.P.');
  txtmove(1,2); txtwrite('Ķ  Ķ');
  for y:=3 to 22 do
    begin
      txtmove(1,y); txtwrite('                                                                    ');
    end;
  txtmove(1,23); txtwrite('ͼ  ͼ');
  txtcolour(Normal2); txtmove(4,0); txtattrib(32); txtmove(44,0); txtattrib(32);
  y:=1; Fin:=false;
  while (y <= 20) and (not Fin) do
    begin
      with Classement1[y] do
        if Total > 0
           then
             begin
               txtcolour(Clr1); txtmove(2,y + 2); txtwrite(Date);
               txtcolour(Clr2); txtmove(13,y + 2); txtwrite(NomJoueur);
               txtcolour(Clr3); txtmove(29,y + 2); txtnumwrite(Total,4);
               txtcolour(Clr4); txtmove(34,y + 2); txtnumwrite(TotalPrimes,4);
             end
           else
             Fin:=true;
      inc(y);
    end;
  y:=1; Fin:=false;
  while (y <= 20) and (not Fin) do
    begin
      with Classement2[y] do
        if Total > 0
           then
             begin
               txtcolour(Clr1); txtmove(42,y + 2); txtwrite(Date);
               txtcolour(Clr2); txtmove(53,y + 2); txtwrite(NomJoueur);
               txtcolour(Clr4); txtmove(69,y + 2); txtnumwrite(Total,4);
               txtcolour(Clr3); txtmove(74,y + 2); txtnumwrite(TotalPrimes,4);
             end
           else
             Fin:=true;
      inc(y);
    end;
  txtback(black);
  for y:=0 to 23 do begin txtmove(39,y); txtattrib(2); end;
  txtback(Fond1); txtcolour(Normal1);
  txtmove(1,24); txtwrite('                               <     (O)k     >                               ');
  txtback(Fond2); txtcolour(Normal2); txtmove(33,24); txtattrib(14);
  txtflush; mouseeventparams.me_modified:=false;
  if Souris then Void:=txtmousecurson;
  Fin:=false;
  repeat
    if txtkeypressed
       then
         begin
           txtinput(Entree);
           case ord(Entree) of
             0:txtinput(Entree);
             13,79,111:Fin:=true;
           end;
         end;
    if mouseeventparams.me_modified
       then
         with mouseeventparams do
           begin
             if (me_x in [33..46]) and (me_y = 24) then Fin:=true;
             me_modified:=false;
           end;
  until (Fin);
  if Souris then Void:=txtmousecursoff;
  txtback(FondCourant); txtcolour(CouleurCourante); txtmove(xCourant,yCourant); txtcurssize(Haut,Bas);
End;


END.
