
UNIT YAH_HARD;

(* GESTION DE LA SOURIS EN MODE TEXTE POUR LE PROGRAMME YAHTZEE 2.20 ET SES UNITES.
   RECONNAISSANCE DU HARDWARE.
   MODULES INITIALEMENT PREVUS POUR L'UNITE TXT VERSION 3.00 (L'UNITE ETANT
   TOUJOURS AU STADE DE LA CONCEPTION). *)

INTERFACE

Uses DOS,        (* INTERRUPTIONS BIOS *)
     TXT,        (* GESTION D'ECRAN - VERSION 2.00 *)
     MOUSE,      (* GESTION DE LA SOURIS *)
     TESTADAP;   (* RECONNAISSANCE DU HARDWARE *)

Type (* ---------- GESTION DE LA SOURIS *)
     tMouseEventParams=record
                         me_Modified:boolean;   (* INDIQUE QUE MODIFIE *)
                         me_Event:word;   (* MASQUE DES EVENEMENTS APPELANTS *)
                         me_Buttons:word;   (* MASQUE DES BOUTONS DE LA SOURIS *)
                         me_X,me_Y:word;   (* COORDONNEES (TEXTE) DU CURSEUR *)
                         me_XMove,me_YMove:integer;   (* DEPLACEMENT DU CURSEUR (EN MICKEYS) *)
                         me_Valid:boolean;   (* INDIQUE SI LES PARAMETRES SONT SIGNIFICATIFS *)
                       end;
     tMouseParams=record
                    mp_MouseType:byte;   (* TYPE DE SOURIS *)
                    mp_NbButtons:byte;   (* NOMBRE DE BOUTONS *)
                    mp_VersionHi,mp_VersionLo:byte;   (* VERSION DU DRIVER *)
                    mp_DriverSeg,mp_DriverOfs:word;   (* ADRESSE DU DRIVER *)
                    mp_DriverType:word;   (* DRIVER .SYS OU DRIVER .COM *)
                    mp_SaveBufferSize:word;   (* TAILLE DU BUFFER DE SAUVEGARDE *)
                    mp_X,mp_Y:word;   (* COORDONNEES DU CURSEUR *)
                    mp_Page:word;   (* PAGE ACTUELLE DU CURSEUR *)
                    mp_XSpeed,mp_YSpeed:word;   (* VITESSES HORIZ. ET VERT. (MICKEYS/CARACTERE) *)
                    mp_DoubleSpeed:word;   (* SEUIL DE DOUBLEMENT DE LA VITESSE *)
                    mp_Mask1,mp_Mask2:word;   (* MASQUES DU CURSEUR / DEBUT-FIN BALAYAGE *)
                    mp_ButtonsDown:word;   (* MASQUE DES BOUTONS ENFONCES *)
                    mp_CursorType:word;   (* TYPE DE CURSEUR *)
                    mp_CursorCounter:word;   (* COMPTEUR DE CURSEUR INTERNE *)
                    mp_IntFreq:word;   (* FREQUENCE D'INTERRUPTION DU DRIVER *)
                    mp_Valid:boolean;   (* INDIQUE SI LES PARAMETRES SONT SIGNIFICATIFS *)
                  end;
     tTextParams=record
                   tp_ModeType:byte;   (* MODE COULEUR OU MONOCHROME *)
                 end;
     tDriveTab=array[0..25] of boolean;   (* DRIVES INSTALLES *)


Const (* ---------- GESTION DE LA SOURIS *)
      MouseError:integer=0;   (* CODE DE LA DERNIERE ERREUR SOURIS *)
      MouseEventParams:tMouseEventParams=(me_Modified:false;
                                          me_Event:$0000;
                                          me_Buttons:$0000;
                                          me_X:0; me_Y:0;
                                          me_XMove:0; me_YMove:0;
                                          me_Valid:false);
      MouseParams:tMouseParams=(mp_MouseType:0;
                                mp_NbButtons:0;
                                mp_VersionHi:0; mp_VersionLo:0;
                                mp_DriverSeg:$0000; mp_DriverOfs:$0000;
                                mp_DriverType:$FFFF;
                                mp_SaveBufferSize:0;
                                mp_X:0; mp_Y:0;
                                mp_Page:0;
                                mp_XSpeed:0; mp_YSpeed:0; mp_DoubleSpeed:0;
                                mp_Mask1:$0000; mp_Mask2:$0000;
                                mp_ButtonsDown:$0000;
                                mp_CursorType:$FFFF;
                                mp_CursorCounter:$0000;
                                mp_IntFreq:$0000;
                                mp_Valid:false);
      TextParams:tTextParams=(tp_ModeType:1);   (* MODE COULEUR *)
      Test_Systems:boolean=true;
      (* EVENEMENTS SOURIS *)
      me_MouseMove=$0001;
      me_LButtonDown=$0002;
      me_LButtonUp=$0004;
      me_RButtonDown=$0008;
      me_RButtonUp=$0010;
      me_MButtonDown=$0020;
      me_MButtonUp=$0040;
      me_Shift=$0020;
      me_Ctrl=$0040;
      me_Alt=$0080;
      (* TYPES DE GESTIONNAIRE D'EVENEMENTS SOURIS *)
      me_Normal=0;
      me_Alternate=1;
      (* TYPES DE SOURIS *)
      mp_Bus=1;
      mp_Serial=2;
      mp_InPort=3;
      mp_Ps2=4;
      mp_Hp=5;
      (* BOUTONS SOURIS *)
      mp_LButton=0;
      mp_RButton=1;
      mp_MButton=2;
      (* BOUTONS SOURIS APPUYES *)
      mp_LButtonDown=$0001;
      mp_RButtonDown=$0002;
      mp_MButtonDown=$0004;
      (* TYPES DE DRIVERS SOURIS *)
      mp_Com=$0000;
      mp_Sys=$8000;
      (* TYPES DE CURSEURS SOURIS *)
      mc_Log=$0000;
      mc_Electronic=$1000;
      mc_Graphic=$2000;
      (* OPTIONS DES MASQUES DU CURSEUR SOURIS *)
      mc_Keep=0;
      mc_Replace=1;
      mc_Invert=2;
      (* FREQUENCES D'INTERRUPTION SOURIS *)
      mp_0ips=$0001;
      mp_30ips=$0002;
      mp_50ips=$0004;
      mp_100ips=$0008;
      mp_200ips=$0010;

      (* ---------- OPTIONS DE TXTVALIDATE *)
      tv_ArUp=$8000;   (* FLECHE HAUT *)
      tv_ArDn=$4000;   (* FLECHE BAS *)
      tv_PgUp=$2000;   (* PAGE HAUT *)
      tv_PgDn=$1000;   (* PAGE BAS *)
      tv_TabRi=$0800;   (* TAB DROITE *)
      tv_TabLe=$0400;   (* TAB GAUCHE *)
      tv_CtrlEnter=$0200;   (* CTRL-ENTER *)
      tv_CtrlArUp=$0100;   (* CTRL-FLECHE HAUT *)
      tv_CtrlArDn=$0080;   (* CTRL-FLECHE BAS *)
      tv_CtrlPgUp=$0040;   (* CTRL-PAGE HAUT *)
      tv_CtrlPgDn=$0020;   (* CTRL-PAGE BAS *)
      tv_CtrlHome=$0010;   (* CTRL-HOME  *)
      tv_CtrlEnd=$0008;   (* CTRL-END *)
      tv_Escape=$0004;   (* ESCAPE *)
      tv_Insert=$0002;   (* MODE INSERTION AU DEMARRAGE *)
      tv_UpCase=$0001;   (* CONVERSION EN MAJUSCULES *)
      tv_Enter=$0000;   (* ENTER *)

      (* ---------- RECONNAISSANCE DU HARDWARE *)
      (* CARTES VIDEO *)    (* MONITEURS *)
      vc_None = $00;        vm_None = $00;
      vc_Unknown = $00;     vm_Unknown = $00;
      vc_Mda = $01;         vm_Mono = $01;
      vc_Cga = $02;         vm_Colour = $02;
      vc_Hercules = $04;    vm_MonoAnalog = $04;
      vc_Ega = $08;         vm_ColourAnalog = $08;
      vc_Mcga = $10;        vm_EgaHiRes = 10;
      vc_Vga = $20;         vm_Error = $80;
      vc_SvgaVesa = $40;
      vc_Error = $80;
      (* TYPES D'ORDINATEUR *)
      ct_Unknown = 0;
      ct_Pc = 1;
      ct_PcBiosXt = 2;
      ct_PcConv = 3;
      ct_PcJr = 4;
      ct_Xt = 5;
      ct_Xt286 = 6;
      ct_At = 7;
      ct_Ps2Mod25 = 8;
      ct_Ps2Mod30 = 9;
      ct_Ps2Mod50 = 10;
      ct_Ps2Mod60 = 11;
      ct_Ps2Mod80 = 12;
      ct_At_Ps2_Xt286 = 101;
      ct_Ps2 = 102;
      ct_Error = 255;

      TextError:integer=0;

(* ---------- GESTION DE LA SOURIS *)
Function TXTINITMOUSE (var Statut:integer) : boolean;
   (* INITIALISATION DU DRIVER ET DES PARAMETRES DE LA SOURIS *)
Function TXTDETECTMOUSE : boolean;
   (* DETECTE LA PRESENCE D'UN DRIVER DE SOURIS *)
Function TXTMOUSESAVEBUFFERSIZE : word;
   (* DETERMINE LA TAILLE DU BUFFER DE SAUVEGARDE DES PARAMETRES DE LA SOURIS *)
Function TXTSAVEMOUSE (Buffer:pointer) : boolean;
   (* SAUVE LES PARAMETRES DU DRIVER DE SOURIS DANS UN BUFFER *)
Function TXTLOADMOUSE (Buffer:pointer) : boolean;
   (* CHARGE DES PARAMETRES DU DRIVER DE SOURIS SAUVES PAR TXTSAVEMOUSE *)
Function TXTDISACTIVATEMOUSE : boolean;
   (* DESACTIVE LE DRIVER DE SOURIS *)
Function TXTREACTIVATEMOUSE : boolean;
   (* REACTIVE LE DRIVER DE LA SOURIS DESACTIVE PAR TXTDISACTIVATEMOUSE *)
Function TXTMOUSEINTERRUPTFREQUENCY (Frequency:word) : boolean;
   (* FIXE LA FREQUENCE D'INTERRUPTION DU DRIVER DE LA SOURIS *)
Function TXTMOUSESPEED (x_Speed,y_Speed,Double_Speed:word) : boolean;
   (* FIXE LES VITESSES HORIZONTALE ET VERTICALE ET LE SEUIL DE DOUBLEMENT DE LA VITESSE DE LA SOURIS *)
Function TXTGETMOUSESPEED (var x_Speed,y_Speed,Double_Speed:word) : boolean;
   (* DETERMINE LES VITESSES HORIZONTALE ET VERTICALE ET LE SEUIL DE DOUBLEMENT DE LA VITESSE DE LA SOURIS *)
Procedure EVENTHND;
   (* INTERFACE STANDARD ENTRE LE GESTIONNAIRE D'EVENEMENTS NORMAL ET LE DRIVER DE SOURIS *)
Procedure EVENTHANDLER (Events,Buttons,x,y:word; x_Move,y_Move:integer);
   (* GESTIONNAIRE D'EVENEMENTS NORMAL STANDARD *)
Procedure EVENTH2;
   (* INTERFACE STANDARD ENTRE LE GESTIONNAIRE D'EVENEMENTS ALTERNE ET LE DRIVER DE SOURIS *)
Procedure EVENTHANDLER2 (Events,Buttons,x,y:word; x_Move,y_Move:integer);
   (* GESTIONNAIRE D'EVENEMENTS ALTERNE (AVEC TOUCHES DU CLAVIER) STANDARD *)
Function TXTINSTALLMOUSEEVENTHANDLER (Handler_Type:byte; Handler_Addr:pointer; Events:word) : boolean;
   (* INSTALLE UN GESTIONNAIRE D'EVENEMENTS *)
Function TXTMOUSECURSOFF : boolean;
   (* ETEINT LE CURSEUR DE LA SOURIS *)
Function TXTMOUSECURSON : boolean;
   (* ALLUME LE CURSEUR DE LA SOURIS *)
Function TXTGETMOUSECURSORCOUNTER (var Counter:word) : boolean;
   (* RETOURNE LE COMPTEUR DE CURSEUR INTERNE DU DRIVER *)
Function TXTMOUSECURSORMASKS (CharOption,NewChar,ColourOption,NewColour:byte; var And_Mask,Xor_Mask:word) : boolean;
   (* CONSTRUIT LES MASQUES AND ET XOR DU CURSEUR LOGIQUE DE LA SOURIS *)
Function TXTMOUSECURSOR (CursorType,Mask1,Mask2:word) : boolean;
   (* DEFINIT L'ASPECT DU CURSEUR SOURIS *)
Function TXTGETMOUSECURSORMASKS (var Mask1,Mask2:word) : boolean;
   (* RETOURNE LES MASQUES DU CURSEUR DE SOURIS *)
Function TXTGETCURSORMOVE (var x_Move,y_Move:integer) : boolean;
   (* DTM LA DISTANCE ENTRE LA POSITION ACTUELLE DU CURSEUR ET SA POSITION LORS DE L'APPEL PRECEDENT DE LA FONCTION *)
Function TXTGETBUTTONDOWNCOUNTER (Button:word; var Counter,x,y:word) : boolean;
   (* DETERMINE LE NOMBRE DE FOIS QU'UN BOUTON A ETE ENFONCE DEPUIS LE DERNIER APPEL DE LA FONCTION *)
Function TXTGETBUTTONUPCOUNTER (Button:word; var Counter,x,y:word) : boolean;
   (* DETERMINE LE NOMBRE DE FOIS QUE LE BOUTON Bouton A ETE RELACHE DEPUIS LE DERNIER APPEL DE LA FONCTION *)

(* ---------- RECONNAISSANCE DU HARDWARE *)
Function TXTGETCOMPUTERTYPE (var Type_Ordinateur:byte) : boolean;
   (* DETERMINE LE TYPE D'ORDINATEUR *)
Function TXTGETBIOSDATE (var Jour,Mois,Annee:word) : boolean;
   (* DETERMINE LA DATE DU BIOS *)
Function TXTGETVIDEOSYSTEMS (var Carte1,Moniteur1,Carte2,Moniteur2:byte) : boolean;
   (* TESTE LA (LES) CARTE(S) VIDEO ET LE (LES) MONITEUR(S) INSTALLE(S) *)

(* ---------- UNITE TXT 3.00 *)
Function TXTVALIDATE2 (Source:string; var Dest:string; lChaine:byte; Option:word; Filtre:ByteSet) : word;
   (* MODIFICATION D'UNE CHAINE EXISTANTE *)


IMPLEMENTATION

(* ---------- GESTION DE LA SOURIS *)

Function TXTINITMOUSE (var Statut:integer) : boolean;
(* INITIALISATION DU DRIVER ET DES PARAMETRES DE LA SOURIS.
   Statut CONTIENT LE CODE D'ERREUR (DE MEME QUE MouseError).
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = ERREUR. *)
Var Ok:boolean;
    Mot:word;
Begin
  MouseError:=0; Statut:=0;
  with MouseParams do
    begin
      Ok:=TEST_SOURIS(mp_NbButtons);
      if Ok
         then
           begin
             TYPE_SOURIS(mp_VersionHi,mp_VersionLo,mp_MouseType);
             PARAMETRES_SOURIS(mp_ButtonsDown,mp_X,mp_Y);
             mp_SaveBufferSize:=TAILLE_BUFFER_SAUVEGARDE;
             mp_Page:=PAGE_SOURIS;
             VITESSE_SOURIS(mp_XSpeed,mp_YSpeed,mp_DoubleSpeed);
             if ((mp_VersionHi * 100) + mp_VersionLo) >= 626
                then
                  begin
                    Mot:=INFORMATIONS_DRIVER;
                    if (Mot and $8000) = $0000 then mp_DriverType:=mp_Com else mp_DriverType:=mp_Sys;
                    if (Mot and $2000) = $0000
                       then
                         begin
                           if (Mot and $1000) = $0000 then mp_CursorType:=mc_Log else mp_CursorType:=mc_Electronic;
                         end
                       else
                         mp_CursorType:=mc_Graphic;
                    mp_IntFreq:=(Mot shr 8) and $000F;
                  end;
             if ((mp_VersionHi * 100) + mp_VersionLo) >= 701 then MASQUES_CURSEUR(mp_Mask1,mp_Mask2);
             if ((mp_VersionHi * 100) + mp_VersionLo) >= 702 then mp_CursorCounter:=COMPTEUR_CURSEUR;
             mp_Valid:=true;
           end
         else
           begin
             Statut:=-1; MouseError:=-1;
           end;
    end;
  TXTINITMOUSE:=Ok;
End;


{$F+}
Procedure EVENTHANDLER (Events,Buttons,x,y:word; x_Move,y_Move:integer);
(* GESTIONNAIRE D'EVENEMENTS STANDARD.
   SE CONTENTE DE CHARGER LES DONNEES DU DRIVER DANS LA VARIABLE
   MouseEventParams.
   L'UTILISATEUR PEUT REDEFINIR CETTE PROCEDURE, MAIS DOIT EN GARDER L'EN-TETE.
   IMPORTANT : DOIT ETRE PROCEDURE FAR !
   IL EST A EVITER DE FAIRE DES SORTIES VIDEO VIA LE BIOS (POUR NE PAS PLANTER
   LE DRIVER DE SOURIS).
   Events EST LE MASQUE DES EVENEMENTS AYANT DECLENCHE LE GESTIONNAIRE;
   Buttons EST LE MASQUE DES BOUTONS DE LA SOURIS ENFONCES;
   x,y SONT LES COORDONNEES DU CURSEUR DE LA SOURIS;
   x_Move ET y_Move SONT LES DEPLACEMENTS DE LA SOURIS (EN MICKEYS). *)
Begin
  with MouseEventParams do
    begin
      me_Modified:=true;
      me_Event:=Events;
      me_Buttons:=Buttons;
      me_X:=x; me_Y:=y;
      me_XMove:=x_Move; me_YMove:=y_Move;
      me_Valid:=true;
    end;
End;


Procedure EVENTHANDLER2 (Events,Buttons,x,y:word; x_Move,y_Move:integer);
(* GESTIONNAIRE D'EVENEMENTS ALTERNE (AVEC TOUCHES DU CLAVIER).
   SE CONTENTE DE CHARGER LES DONNEES DU DRIVER DANS LA VARIABLE
   MouseEventParams.
   L'UTILISATEUR PEUT REDEFINIR CETTE PROCEDURE, MAIS DOIT EN GARDER L'EN-TETE.
   IMPORTANT : DOIT ETRE PROCEDURE FAR !
   IL EST A EVITER DE FAIRE DES SORTIES VIDEO VIA LE BIOS (POUR NE PAS PLANTER
   LE DRIVER DE SOURIS).
   Events EST LE MASQUE DES EVENEMENTS AYANT DECLENCHE LE GESTIONNAIRE;
   Buttons EST LE MASQUE DES BOUTONS DE LA SOURIS ENFONCES;
   x,y SONT LES COORDONNEES DU CURSEUR DE LA SOURIS;
   x_Move ET y_Move SONT LES DEPLACEMENTS DE LA SOURIS (EN MICKEYS). *)
Begin
  with MouseEventParams do
    begin
      me_Modified:=true;
      me_Event:=Events;
      me_Buttons:=Buttons;
      me_X:=x; me_Y:=y;
      me_XMove:=x_Move; me_YMove:=y_Move;
      me_Valid:=true;
    end;
End;
{$F-}


{$F+}
{$L EVENTHND}
Procedure EVENTHND; external;
(* INTERFACE ENTRE LE GESTIONNAIRE D'EVENEMENTS NORMAL ET LE DRIVER DE SOURIS *)

{$L EVENTH2}
Procedure EVENTH2; external;
(* INTERFACE ENTRE LE GESTIONNAIRE D'EVENEMENTS ALTERNE ET LE DRIVER DE SOURIS *)
{$F-}


Function TXTINSTALLMOUSEEVENTHANDLER (Handler_Type:byte; Handler_Addr:pointer; Events:word) : boolean;
(* INSTALLE UN GESTIONNAIRE D'EVENEMENTS.
   Events EST LA COMBINAISON LOGIQUE (OR) DES EVENEMENTS A DETECTER.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = ERREUR. *)
Var Ok:boolean;
Begin
  MouseError:=0;
  case Handler_Type of
    me_Normal:begin
                Ok:=INSTALLER_GESTIONNAIRE_EVENEMENTS(Handler_Type,Events,longint(Handler_Addr));
                if not Ok then MouseError:=-21;
              end;
     me_Alternate:begin
                    Ok:=INSTALLER_GESTIONNAIRE_EVENEMENTS(Handler_Type,Events,longint(Handler_Addr));
                    if not Ok then MouseError:=-21;
                  end;
  else
    Ok:=false; MouseError:=-22;
  end;
  TXTINSTALLMOUSEEVENTHANDLER:=Ok;
End;


Function TXTGETMOUSECURSORCOUNTER (var Counter:word) : boolean;
(* RETOURNE LE COMPTEUR DE CURSEUR INTERNE DU DRIVER.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = VERSION DRIVER INCORRECTE. *)
Var Ok:boolean;
Begin
  MouseError:=0;
  with MouseParams do
    begin
      if mp_Valid
         then
           begin
             if ((mp_VersionHi * 100) + mp_VersionLo) >= 702 then Ok:=true else Ok:=false;
           end
         else
           Ok:=true;
    end;
  if Ok then Counter:=COMPTEUR_CURSEUR else MouseError:=-3;
  TXTGETMOUSECURSORCOUNTER:=Ok;
End;


Function TXTGETMOUSECURSORMASKS (var Mask1,Mask2:word) : boolean;
(* RETOURNE LES MASQUES DU CURSEUR DE SOURIS.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = VERSION DRIVER INCORRECTE. *)
Var Ok:boolean;
Begin
  MouseError:=0;
  with MouseParams do
    begin
      if mp_Valid
         then
           begin
             if ((mp_VersionHi * 100) + mp_VersionLo) >= 701 then Ok:=true else Ok:=false;
           end
         else
           Ok:=true;
    end;
  if Ok then MASQUES_CURSEUR(Mask1,Mask2) else MouseError:=-3;
  TXTGETMOUSECURSORMASKS:=Ok;
End;


Function TXTDETECTMOUSE : boolean;
(* DETECTE LA PRESENCE D'UN DRIVER DE SOURIS.
   VALEURS RETOURNEES PAR LA FONCTION : True = DRIVER PRESENT (MouseError = 0),
                                        False = DRIVER ABSENT (MouseError = -1). *)
Var Ok:boolean;
    n:byte;   (* VARIABLE NON UTILISEE *)
Begin
  Ok:=TEST_SOURIS(n);
  if Ok then MouseError:=0 else MouseError:=-1;
  TXTDETECTMOUSE:=Ok;
End;


Function TXTMOUSESAVEBUFFERSIZE : word;
(* DETERMINE LA TAILLE DU BUFFER DE SAUVEGARDE DES PARAMETRES DE LA SOURIS *)
Begin
  TXTMOUSESAVEBUFFERSIZE:=TAILLE_BUFFER_SAUVEGARDE;
End;


Function TXTSAVEMOUSE (Buffer:pointer) : boolean;
(* SAUVE LES PARAMETRES DU DRIVER DE SOURIS DANS UN BUFFER DONT LA TAILLE PEUT
   ETRE DETERMINEE PAR MouseParams.mpBufferSize OU PAR TxtMouseSaveBufferSize.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = ERREUR D'ADRESSAGE. *)
Begin
  MouseError:=0;
  if Buffer <> nil
     then
       begin
         TXTSAVEMOUSE:=true; SAUVEGARDER_RESTAURER_ETAT(0,Buffer);
       end
     else
       begin
         TXTSAVEMOUSE:=false; MouseError:=-4;
       end;
End;


Function TXTLOADMOUSE (Buffer:pointer) : boolean;
(* CHARGE DES PARAMETRES DU DRIVER DE SOURIS SAUVES DANS UN BUFFER.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = ERREUR D'ADRESSAGE. *)
Begin
  MouseError:=0;
  if Buffer <> nil
     then
       begin
         TXTLOADMOUSE:=true; SAUVEGARDER_RESTAURER_ETAT(1,Buffer);
       end
     else
       begin
         TXTLOADMOUSE:=false; MouseError:=-4;
       end;
End;


Function TXTMOUSECURSOFF : boolean;
(* ETEINT LE CURSEUR DE LA SOURIS.
   VALEUR RENVOYEE PAR LA FONCTION : TOUJOURS True = PAS D'ERREUR. *)
Begin
  MouseError:=0; TXTMOUSECURSOFF:=true;
  AFFICHER_EFFACER_CURSEUR(0);
End;


Function TXTMOUSECURSON : boolean;
(* ALLUME LE CURSEUR DE LA SOURIS.
   VALEUR RENVOYEE PAR LA FONCTION : TOUJOURS True = PAS D'ERREUR. *)
Begin
  MouseError:=0; TXTMOUSECURSON:=true;
  AFFICHER_EFFACER_CURSEUR(1);
End;


Function TXTMOUSECURSORMASKS (CharOption,NewChar,ColourOption,NewColour:byte; var And_Mask,Xor_Mask:word) : boolean;
(* CONSTRUIT LES MASQUES AND ET XOR DU CURSEUR LOGIQUE DE LA SOURIS.
   CharOption : 0 = GARDER LE CARACTERE,
                1 = REMPLACER LE CARACTERE PAR NewChar;
   ColourOption : 0 = GARDER LA COULEUR,
                  1 = REMPLACER LA COULEUR PAR NewColour,
                  2 = INVERSER LA COULEUR.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = OPTION INCONNUE. *)
Var Registres:registers;
    Ok:boolean;
Begin
  MouseError:=0; Ok:=true;
  with Registres do
    begin
      (* MASQUE DU CARACTERE (cl ET dl) *)
      case CharOption of
        mc_Keep:begin cl:=$FF; dl:=$00; end;
        mc_Replace:begin cl:=$00; dl:=NewChar; end;
      else
        Ok:=false;
      end;
      if Ok
         then
           begin
             (* MASQUE DE LA COULEUR (ch ET dh) *)
             case ColourOption of
               mc_Keep:begin ch:=$FF; dh:=$00; end;
               mc_Replace:begin ch:=$00; dh:=NewColour; end;
               mc_Invert:begin ch:=$FF; dh:=$FF; end;
             else
               Ok:=false;
             end;
           end;
      if Ok
         then
           begin
             And_Mask:=cx; Xor_Mask:=dx;
           end
         else
           MouseError:=-33;
    end;
  TXTMOUSECURSORMASKS:=Ok;
End;


Function TXTMOUSECURSOR (CursorType,Mask1,Mask2:word) : boolean;
(* DEFINIT L'ASPECT DU CURSEUR SOURIS.
   VALEURS RENVOYEES PAR LA FONCTION : True = PAS D'ERREUR,
                                       False = ERREUR DANS MouseError. *)
Begin
  MouseError:=0; TXTMOUSECURSOR:=true;
  case CursorType of
    mc_Log:DEFINITION_CURSEUR(CursorType,Mask1,Mask2);
    mc_Electronic:begin
                    if Test_Systems
                       then
                         begin
                           if TextParams.tp_ModeType = 0
                              then
                                begin   (* MODE MONOCHROME PUR *)
                                  if (Mask1<=15) and (Mask2<=15)
                                     then
                                       DEFINITION_CURSEUR(CursorType,Mask1,Mask2)
                                     else
                                       begin
                                         MouseError:=-32; TXTMOUSECURSOR:=false;
                                       end;
                                end
                              else
                                begin   (* MODE COULEUR OU NIVEAUX DE GRIS *)
                                  if (Mask1<=7) and (Mask2<=7)
                                     then
                                       DEFINITION_CURSEUR(CursorType,Mask1,Mask2)
                                     else
                                       begin
                                         MouseError:=-32; TXTMOUSECURSOR:=false;
                                       end;
                                end;
                         end;
                  end;
  else
    TXTMOUSECURSOR:=false; MouseError:=-31;
  end;
End;


Function TXTMOUSEINTERRUPTFREQUENCY (Frequency:word) : boolean;
(* FIXE LA FREQUENCE D'INTERRUPTION DU DRIVER DE LA SOURIS.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = ERREUR. *)
Var Ok:boolean;
Begin
  MouseError:=0; Ok:=true;
  if Test_Systems then
  if MouseParams.mp_Valid then
  if MouseParams.mp_MouseType <> mp_InPort
     then
       begin
         Ok:=false; MouseError:=-2;
       end;
  if Ok then
  if Frequency in [mp_0ips,mp_30ips,mp_50ips,mp_100ips,mp_200ips]
     then
       FREQUENCE_INTERRUPTION(Frequency)
     else
       begin
         Ok:=false; MouseError:=-5;
       end;
  TXTMOUSEINTERRUPTFREQUENCY:=Ok;
End;


Function TXTMOUSESPEED (x_Speed,y_Speed,Double_Speed:word) : boolean;
(* FIXE LES VITESSES HORIZONTALE ET VERTICALE ET LE SEUIL DE DOUBLEMENT DE LA
   VITESSE DE LA SOURIS (EN MICKEYS/8 PIXELS). VALEURS : 1 A 32767.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = VITESSE HORS LIMITES. *)
Begin
  MouseError:=0; TXTMOUSESPEED:=true;
  if (x_Speed>=1) and (x_Speed<=maxint) and (y_Speed>=1) and (y_Speed<=maxint) and
     (Double_Speed>=1) and (Double_Speed<=maxint)
     then
       FIXER_VITESSE_SOURIS(x_Speed,y_Speed,Double_Speed)
     else
       begin
         MouseError:=-34; TXTMOUSESPEED:=false;
       end;
End;


Function TXTGETMOUSESPEED (var x_Speed,y_Speed,Double_Speed:word) : boolean;
(* DETERMINE LES VITESSES HORIZONTALE ET VERTICALE ET LE SEUIL DE DOUBLEMENT DE
   LA VITESSE DE LA SOURIS (EN MICKEYS/8 PIXELS).
   VALEUR RETOURNEE PAR LA FONCTION : TOUJOURS True = PAS D'ERREUR. *)
Begin
  MouseError:=0; TXTGETMOUSESPEED:=true;
  VITESSE_SOURIS(x_Speed,y_Speed,Double_Speed);
End;


Function TXTDISACTIVATEMOUSE : boolean;
(* DESACTIVE LE DRIVER DE SOURIS ET CHARGE SON ADRESSE DANS MouseParams.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = ERREUR. *)
Var Ok:boolean;
Begin
  MouseError:=0;
  Ok:=DESACTIVER_DRIVER(MouseParams.mp_DriverSeg,MouseParams.mp_DriverOfs);
  if not Ok then MouseError:=-10;
  TXTDISACTIVATEMOUSE:=Ok;
End;


Function TXTREACTIVATEMOUSE : boolean;
(* REACTIVE LE DRIVER DE LA SOURIS DESACTIVE PAR TxtDisactivateMouse.
   REMET L'ADRESSE DU DRIVER DANS MouseParams A ZERO.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = DRIVER NON DESACTIVE. *)
Begin
  with MouseParams do
    begin
      if (mp_DriverSeg <> $0000) or (mp_DriverOfs <> $0000)
         then
           begin
             REACTIVER_DRIVER;
             mp_DriverSeg:=$0000; mp_DriverOfs:=$0000;
             MouseError:=0; TXTREACTIVATEMOUSE:=true;
           end
         else
           begin
             MouseError:=-11; TXTREACTIVATEMOUSE:=false;
           end;
    end;
End;


Function TXTGETCURSORMOVE (var x_Move,y_Move:integer) : boolean;
(* DETERMINE LA DISTANCE ENTRE LA POSITION ACTUELLE DU CURSEUR ET SA POSITION
   LORS DE L'APPEL PRECEDENT DE LA FONCTION.
   VALEUR RETOURNEE PAR LA FONCTION : TOUJOURS True = PAS D'ERREUR. *)
Begin
  MouseError:=0; TXTGETCURSORMOVE:=true;
  MOUVEMENTS_CURSEUR(x_Move,y_Move);
End;


Function TXTGETBUTTONDOWNCOUNTER (Button:word; var Counter,x,y:word) : boolean;
(* DETERMINE LE NOMBRE DE FOIS QUE LE BOUTON Bouton A ETE ENFONCE DEPUIS LE
   DERNIER APPEL DE LA FONCTION. RETOURNE EGALEMENT LA POSITION DU CURSEUR LORS
   DU DERNIER ENFONCEMENT DU BOUTON.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = BOUTON INVALIDE. *)
Var Ok:boolean;
Begin
  MouseError:=0; Ok:=true;
  if Test_Systems
     then
       begin
         if MouseParams.mp_Valid then if Button >= MouseParams.mp_NbButtons then Ok:=false;
       end
     else
       begin
         if Button > mp_MButton then ok:=false;
       end;
  if Ok then NOMBRE_FOIS_BOUTON(0,Button,Counter,x,y) else MouseError:=-35;
  TXTGETBUTTONDOWNCOUNTER:=Ok;
End;


Function TXTGETBUTTONUPCOUNTER (Button:word; var Counter,x,y:word) : boolean;
(* DETERMINE LE NOMBRE DE FOIS QUE LE BOUTON Bouton A ETE RELACHE DEPUIS LE
   DERNIER APPEL DE LA FONCTION. RETOURNE EGALEMENT LA POSITION DU CURSEUR LORS
   DU DERNIER RELACHEMENT DU BOUTON.
   VALEURS RETOURNEES PAR LA FONCTION : True = PAS D'ERREUR,
                                        False = BOUTON INVALIDE. *)
Var Ok:boolean;
Begin
  MouseError:=0; Ok:=true;
  if Test_Systems
     then
       begin
         if MouseParams.mp_Valid then if Button >= MouseParams.mp_NbButtons then Ok:=false;
       end
     else
       begin
         if Button > mp_MButton then ok:=false;
       end;
  if Ok then NOMBRE_FOIS_BOUTON(1,Button,Counter,x,y) else MouseError:=-35;
  TXTGETBUTTONUPCOUNTER:=Ok;
End;


(* ---------- RECONNAISSANCE DU HARDWARE *)

Function TXTGETCOMPUTERTYPE (var Type_Ordinateur:byte) : boolean;
(* DETERMINE LE TYPE D'ORDINATEUR.
   Type_Ordinateur : DES VALEURS ENTRE 1 ET 100 SIGNIFIENT QUE LE TYPE A PU ETRE
                     DETERMINE AVEC PRECISION, TANDIS QUE DES VALEURS >100
                     INDIQUENT QU'IL S'AGIT D'UN TYPE APPROXIMATIF. 255 INDIQUE
                     UNE ERREUR.
   VALEUR RENVOYEE PAR LA FONCTION : TOUJOURS True = PAS D'ERREUR. *)
Const Inconnu = 0;
      Pc = 1;
      Pc_BiosXt = 2;
      Pc_Convertible = 3;
      PcJr = 4;
      Xt = 5;
      Xt286 = 6;
      At = 7;
      Ps2_Model_25 = 8;
      Ps2_Model_30 = 9;
      Ps2_Model_50 = 10;
      Ps2_Model_60 = 11;
      Ps2_Model_80 = 12;
      At_Ps2_Xt286 = 101;
      Ps2 = 102;
      Erreur = 255;
Type Tableau = array[0..7] of byte;
Var Registres:registers;
    Donnees:^Tableau;
    Modele,Sous_Modele,Revision_Bios:byte;
Begin
  TextError:=0;
  with Registres do
    begin
      ah:=$C0;
      intr($15,Registres);
      if (ah=0) and ((flags and fcarry)=0)
         then
           begin   (* LA FONCTION EST SUPPORTEE PAR LE BIOS *)
             Donnees:=ptr(es,bx);   (* BUFFER EN ES:BX *)
             Modele:=Donnees^[2]; Sous_Modele:=Donnees^[3]; Revision_Bios:=Donnees^[4];
             case Modele of
               $F8:Type_Ordinateur:=Ps2_Model_80;
               $F9:Type_Ordinateur:=Pc_Convertible;
               $FA:begin
                     case Sous_Modele of
                       0:Type_Ordinateur:=Ps2_Model_30;
                       1:Type_Ordinateur:=Ps2_Model_25;
                     else
                       Type_Ordinateur:=Ps2;
                     end;
                   end;
               $FB:Type_Ordinateur:=Xt;
               $FC:begin
                     case Sous_Modele of
                       2:Type_Ordinateur:=Xt286;
                       4:Type_Ordinateur:=Ps2_Model_50;
                       5:Type_Ordinateur:=Ps2_Model_60;
                     else
                       Type_Ordinateur:=At;
                     end;
                   end;
               $FD:Type_Ordinateur:=PcJr;
               $FE:Type_Ordinateur:=Xt;
               $FF:begin
                     case Revision_Bios of
                       2:Type_Ordinateur:=Pc_BiosXt;
                     else
                       Type_Ordinateur:=Pc;
                     end;
                   end;
             end;
           end
         else
           begin   (* LA FONCTION N'EST PAS SUPPORTEE PAR LE BIOS *)
             Modele:=mem[$F000:$FFFE];
             case Modele of
               $F8:Type_Ordinateur:=Ps2_Model_80;
               $F9:Type_Ordinateur:=Pc_Convertible;
               $FA:Type_Ordinateur:=Ps2;
               $FB:Type_Ordinateur:=Xt;
               $FC:Type_Ordinateur:=At_Ps2_Xt286;
               $FD:Type_Ordinateur:=PcJr;
               $FE:Type_Ordinateur:=Xt;
               $FF:Type_Ordinateur:=Pc;
             else
               Type_Ordinateur:=Inconnu;
             end;
           end;
    end;
  TXTGETCOMPUTERTYPE:=true;
End;


Function TXTGETBIOSDATE (var Jour,Mois,Annee:word) : boolean;
(* DETERMINE LA DATE DU BIOS.
   VALEURS RENVOYEES PAR LA FONCTION : True = PAS D'ERREUR,
                                       False = ERREUR. *)
Type Tableau = array[0..7] of char;
Var Chaine:^Tableau;
    Extrait:string[2];
    Erreur:integer;
    Ok:boolean;
Begin
  TextError:=0;
  Chaine:=ptr($F000,$FFF5);   (* FORMAT : MM/DD/YY *)
  Extrait[0]:=char(2);
  Extrait[1]:=Chaine^[3]; Extrait[2]:=Chaine^[4];
  val(Extrait,Jour,Erreur);
  if Erreur = 0
     then
       begin
         Extrait[1]:=Chaine^[0]; Extrait[2]:=Chaine^[1];
         val(Extrait,Mois,Erreur);
         if Erreur = 0
            then
              begin
                Extrait[1]:=Chaine^[6]; Extrait[2]:=Chaine^[7];
                val(Extrait,Annee,Erreur);
                if Erreur = 0
                   then
                     begin
                       if Annee >= 80 then inc(Annee,1900) else inc(Annee,2000);
                       Ok:=true;
                     end
                   else
                     Ok:=false;
              end
            else
              Ok:=false;
       end
     else
       Ok:=false;
  TXTGETBIOSDATE:=Ok;
  if not Ok then TextError:=-2;
End;


Function TXTGETVIDEOSYSTEMS (var Carte1,Moniteur1,Carte2,Moniteur2:byte) : boolean;
(* TESTE LA (LES) CARTE(S) VIDEO ET LE (LES) MONITEUR(S) INSTALLE(S).
   VALEURS DE CARTES RENVOYEES : VOIR UNITE TestAdap.
   VALEURS DE MONITEURS RENVOYEES : VOIR UNITE TestAdap.
   VALEURS DE FONCTION RENVOYEES : True = PAS D'ERREUR,
                                   False = ERREUR (CODE CHARGE DANS TextError) *)
Var Ok:boolean;
    Mode_Video,s,sBis:byte;
Begin
  TextError:=0;
  Ok:=TEST_VGA_MCGA(Carte1,Moniteur1,Carte2,Moniteur2);
  if Ok
     then
       begin
         if not((Carte1=Vga) or (Carte1=Mcga) or (Carte2=Vga) or (Carte2=Mcga) or
                (Carte1=Svga_Vesa) or (Carte2=Svga_Vesa))
            then
              begin   (* NI CARTE MCGA NI CARTE VGA *)
                Ok:=TEST_EGA(Carte1,Moniteur1);
                If Carte1 = Ega
                   then
                     begin   (* TEST DE L'AUTRE SYSTEME INSTALLE *)
                       case Moniteur1 of
                         Mono:begin
                                Ok:=TEST_CGA(Carte2,Moniteur2);
                                if Carte2 = Cga
                                   then
                                     begin   (* QUEL SYSTEME EST ACTIVE ? *)
                                       Ok:=GETMODE(Mode_Video);
                                       if (Mode_Video<>7) and (Mode_Video<>$0F)
                                          then
                                            begin   (* MODE COULEUR ACTIF *)
                                              s:=Carte1; sBis:=Moniteur1;
                                              Carte1:=Carte2; Moniteur1:=Moniteur2;
                                              Carte2:=s; Moniteur2:=sBis;
                                            end;
                                     end
                                   else
                                     begin   (* PAS DE 2EME SYSTEME *)
                                       Carte2:=Aucun; Moniteur2:=Aucun;
                                     end;
                              end;
                         Couleur:begin
                                   Ok:=TEST_MDA_HERCULES(Carte2,Moniteur2);
                                   if (Carte2=Mda) or (Carte2=Hercules)
                                      then
                                        begin   (* QUEL SYSTEME EST ACTIVE ? *)
                                          Ok:=GETMODE(Mode_Video);
                                          if (Mode_Video=7) or (Mode_Video=$0F)
                                             then
                                               begin   (* MODE MONO ACTIF *)
                                                 s:=Carte1; sBis:=Moniteur1;
                                                 Carte1:=Carte2; Moniteur1:=Moniteur2;
                                                 Carte2:=s; Moniteur2:=sBis;
                                               end;
                                        end
                                      else
                                        begin   (* PAS DE 2EME SYSTEME *)
                                          Carte2:=Aucun; Moniteur2:=Aucun;
                                        end;
                                 end;
                       end;
                     end
                   else
                     begin   (* PAS DE CARTE EGA *)
                       Ok:=TEST_CGA(Carte1,Moniteur1);
                       if Carte1 = Cga
                          then
                            begin   (* TEST DE L'AUTRE SYSTEME INSTALLE *)
                              Ok:=TEST_MDA_HERCULES(Carte2,Moniteur2);
                              if (Carte2=Mda) or (Carte2=Hercules)
                                 then
                                   begin   (* QUEL SYSTEME EST ACTIVE ? *)
                                     Ok:=GETMODE(Mode_Video);
                                     if Mode_Video = 7
                                        then
                                          begin   (* MODE MONO ACTIF *)
                                            s:=Carte1; sBis:=Moniteur1;
                                            Carte1:=Carte2; Moniteur1:=Moniteur2;
                                            Carte2:=s; Moniteur2:=sBis;
                                          end;
                                   end
                                 else
                                   begin   (* PAS DE 2EME SYSTEME *)
                                     Carte2:=Aucun; Moniteur2:=Aucun;
                                   end;
                            end
                          else
                            begin   (* PAS DE CARTE CGA *)
                              Ok:=TEST_MDA_HERCULES(Carte1,Moniteur1);
                              Carte2:=Aucun; Moniteur2:=Aucun;   (* PAS DE 2EME SYSTEME *)
                            end;
                     end;
              end;
       end
     else
       TextError:=-1;
  TXTGETVIDEOSYSTEMS:=Ok;
End;


Function TXTVALIDATE2 (Source:string; var Dest:string; lChaine:byte; Option:word; Filtre:ByteSet) : word;
(* MODIFICATION D'UNE CHAINE EXISTANTE D'UNE LONGUEUR MAXIMALE lChaine.
   LA LECTURE EST THEORIQUEMENT LIMITEE A UNE SEULE LIGNE D'ECRAN (SINON : COMPORTEMENT ALEATOIRE); CETTE
   LIMITATION N'EST PAS TESTEE PAR LA FONCTION : L'UTILISATEUR DOIT PRENDRE SES PRECAUTIONS !
   SI LA 1ERE TOUCHE EST UN CARACTERE, LA CHAINE EST EFFACEE.
   Option EST UNE OPERATION "OR" ENTRE LES OPTIONS SUIVANTES :
   - tv_ArUp      = 1000 0000 0000 0000b = 8000h = FLECHE HAUT;
   - tv_ArDn      = 0100 0000 0000 0000b = 4000h = FLECHE BAS;
   - tv_PgUp      = 0010 0000 0000 0000b = 2000h = PAGE HAUT;
   - tv_PgDn      = 0001 0000 0000 0000b = 1000h = PAGE BAS;
   - tv_TabRi     = 0000 1000 0000 0000b = 0800h = TAB DROITE;
   - tv_TabLe     = 0000 0100 0000 0000b = 0400h = TAB GAUCHE;
   - tv_CtrlEnter = 0000 0010 0000 0000b = 0200h = CTRL-ENTER;
   - tv_CtrlArUp  = 0000 0001 0000 0000b = 0100h = CTRL-FLECHE HAUT;
   - tv_CtrlArDn  = 0000 0000 1000 0000b = 0080h = CTRL-FLECHE BAS;
   - tv_CtrlPgUp  = 0000 0000 0100 0000b = 0040h = CTRL-PAGE HAUT;
   - tv_CtrlPgDn  = 0000 0000 0010 0000b = 0020h = CTRL-PAGE BAS;
   - tv_CtrlHome  = 0000 0000 0001 0000b = 0010h = CTRL-HOME;
   - tv_CtrlEnd   = 0000 0000 0000 1000b = 0008h = CTRL-END;
   - tv_Escape    = 0000 0000 0000 0100b = 0004h = ESCAPE;
   - tv_UpCase    = 0000 0000 0000 0001b = 0001h = CONVERSION EN MAJUSCULES.
   Filtre CONTIENT LES CODES ASCII DES CARACTERES PERMIS.
   VALEUR RETOURNEE PAR LA FONCTION : LA TOUCHE AYANT PROVOQUE LA FIN DE LA LECTURE (VOIR Option). *)
Var Buffer:string;
    Entree:char;
    x,xMin,xMax,x1,y1,x2,y2,CurseurHaut,CurseurBas:word;
    Indice,lBuffer:byte;
    Fin,PremiereTouche:boolean;
          Procedure SUPPRESSION_BLANCS;
          (* SUPPRESSION DES BLANCS A LA FIN DE Buffer AVANT DE QUITTER *)
          Begin
            Indice:=lChaine; while (Buffer[Indice] = ' ') and (Indice > 0)  do dec(Indice); Buffer[0]:=char(Indice);
          End;
Begin
  (* INITIALISATIONS *)
  x:=windx; x1:=windx1; y1:=windy1; x2:=windx2; y2:=windy2; txtgetcurssize(CurseurHaut,CurseurBas);
  Buffer:=Source;
  if length(Buffer) > lchaine then lBuffer:=lChaine else lBuffer:=length(Buffer);
  xMin:=windx; xMax:=xMin + lChaine - 1;
  if length(Buffer) < lChaine then for Indice:=(length(Buffer) + 1) to lChaine do Buffer[Indice]:=' ';
  Buffer[0]:=char(lChaine);
  Indice:=1; PremiereTouche:=true;   (* IL N'Y A PAS ENCORE EU DE TOUCHE PRESSEE *)
  txtwrite(Buffer); txtmove(x,windy);
  (* LECTURES AU CLAVIER *)
  Fin:=false;
  repeat
    txtinput(Entree);
    case ord(Entree) of
      0:begin
          txtinput(Entree);
          case ord(Entree) of
            15:begin   (* TAB GAUCHE *)
                 if (Option and tv_TabLe) <> 0
                    then
                      begin
                        SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_TabLe;
                      end;
               end;
            71:begin   (* HOME : CURSEUR EN DEBUT DE CHAINE  *)
                 if Indice > 1
                    then
                      begin
                        Indice:=1; x:=xMin; txtmove(x,windy); PremiereTouche:=false;
                      end;
               end;
            72:begin   (* FLECHE HAUT *)
                 if (Option and tv_ArUp) <> 0
                    then
                      begin
                        SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_ArUp;
                      end;
               end;
            73:begin   (* PAGE HAUT *)
                 if (Option and tv_PgUp) <> 0
                    then
                      begin
                        SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_PgUp;
                      end;
               end;
            75:begin   (* FLECHE GAUCHE : CURSEUR SUR LE CARACTERE PRECEDENT *)
                 if Indice > 1
                    then
                      begin
                        dec(Indice); dec(x); txtmove(x,windy); PremiereTouche:=false;
                      end;
               end;
            77:begin   (* FLECHE DROITE : CURSEUR SUR LE CARACTERE SUIVANT *)
                 if Indice < lChaine
                    then
                      begin
                        inc(Indice); inc(x); txtmove(x,windy); PremiereTouche:=false;
                      end;
               end;
            79:begin   (* END : CURSEUR EN FIN DE CHAINE  *)
                 Indice:=lChaine; x:=xMax;
                 while (Buffer[Indice] = ' ') and (Indice > 0) do
                   begin
                     dec(Indice); dec(x);
                   end;
                 if Indice < lChaine
                    then
                      begin
                        inc(Indice); inc(x);
                      end;
                 txtmove(x,windy);
                 PremiereTouche:=false;
               end;
            80:begin   (* FLECHE BAS *)
                 if (Option and tv_ArDn) <> 0
                    then
                      begin
                        SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_ArDn;
                      end;
               end;
            81:begin   (* PAGE BAS *)
                 if (Option and tv_PgDn) <> 0
                    then
                      begin
                        SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_PgDn;
                      end;
               end;
            83:begin   (* DELETE : SUPPRESSION DU CARACTERE COURANT *)
                 delete(Buffer,Indice,1); insert(' ',Buffer,lChaine); dec(lBuffer);
                 txtcursoff;
                 txtmove(xMin,windy); txtwrite(Buffer); txtmove(x,windy);
                 txtcurssize(CurseurHaut,CurseurBas);
                 PremiereTouche:=false;
               end;
            117:begin   (* CTRL-END *)
                  if (Option and tv_CtrlEnd) <> 0
                     then
                       begin
                         SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlEnd;
                       end;
                end;
            118:begin   (* CTRL-PAGE BAS *)
                  if (Option and tv_CtrlPgDn) <> 0
                     then
                       begin
                         SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlPgDn;
                       end;
                end;
            119:begin   (* CTRL-HOME *)
                  if (Option and tv_CtrlHome) <> 0
                     then
                       begin
                         SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlHome;
                       end;
                end;
            132:begin   (* CTRL-PAGE HAUT *)
                  if (Option and tv_CtrlPgUp) <> 0
                     then
                       begin
                         SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlPgUp;
                       end;
                end;
            141:begin   (* CTRL-FLECHE HAUT *)
                  if (Option and tv_CtrlArUp) <> 0
                     then
                       begin
                         SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlArUp;
                       end;
                end;
            145:begin   (* CTRL-FLECHE BAS *)
                  if (Option and tv_CtrlArDn) <> 0
                     then
                       begin
                         SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlArDn;
                       end;
                end;
          end;
        end;
      8:begin   (* BACK SPACE : SUPPRESSION DU CARACTERE PRECEDENT *)
          if Indice > 1
             then
               begin
                 delete(Buffer,Indice-1,1); insert(' ',Buffer,lChaine); dec(lBuffer);
                 txtcursoff;
                 txtmove(xMin,windy); txtwrite(Buffer); dec(Indice); dec(x); txtmove(x,windy);
                 txtcurssize(CurseurHaut,CurseurBas);
                 PremiereTouche:=false;
               end;
        end;
      9:begin   (* TAB DROITE *)
          if (Option and tv_TabRi) <> 0
             then
               begin
                 SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_TabRi;
               end;
        end;
      10:begin   (* CTRL-ENTER *)
           if (Option and tv_CtrlEnter) <> 0
              then
                begin
                  SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_CtrlEnter;
                end;
         end;
      13:begin   (* ENTER : VALIDATION DE LA CHAINE LUE *)
           SUPPRESSION_BLANCS; Dest:=Buffer; Fin:=true; TXTVALIDATE2:=tv_Enter;
         end;
      27:begin   (* ESCAPE : ANNULATION DE L'OPERATION *)
           Dest:=Source; Fin:=true; TXTVALIDATE2:=tv_Escape;
         end;
    else   (* AUTRES CARACTERES *)
      if ord(Entree) in Filtre
         then
           begin
             if PremiereTouche
                then   (* MISE A BLANC DE LA CHAINE *)
                  begin
                    for Indice:=1 to lChaine do Buffer[Indice]:=' '; Buffer[0]:=char(lChaine);
                    Indice:=1; PremiereTouche:=false;
                  end;
             if (Option and tv_Upcase) <> 0
                then    (* CONVERSION AUTOMATIQUE EN MAJUSCULES *)
                  case Entree of
                    '','','':Entree:='A';
                    '','','','':Entree:='E';
                    '','','':Entree:='I';
                    '','','':Entree:='O';
                    '','','':Entree:='U';
                    '':Entree:='';
                    '':Entree:='';
                    '':Entree:='';
                    '':Entree:='';
                    '':Entree:='';
                    '':Entree:='Y';
                    '':Entree:='C';
                    '':Entree:='';
                  else
                    Entree:=upcase(Entree);
                  end;
             if Indice = lChaine
                then
                  begin
                    Buffer[Indice]:=Entree; txtwrite(Entree); txtmove(x,windy);
                  end
                else
                  begin
                    delete(Buffer,lChaine,1); insert(Entree,Buffer,Indice);
                    if lBuffer < lChaine then inc(lBuffer);
                    txtcursoff;
                    txtmove(xMin,windy); txtwrite(Buffer); inc(Indice); inc(x); txtmove(x,windy);
                    txtcurssize(CurseurHaut,CurseurBas);
                  end;
           end;
    end;
  until Fin;
End;


END.
